
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package es.gva.cit.catalogClient.ui.search;
import es.gva.cit.catalogClient.CatalogClient;
import es.gva.cit.catalogClient.querys.Query;
import es.gva.cit.catalogClient.ui.showResults.ShowResultsDialog;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Collection;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

import org.gvsig.i18n.Messages;

/**
 * 
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public class SearchDialogPanel extends JPanel implements ItemListener, ActionListener {
//	This component its used to resize the frame
	/**
	 * 
	 * 
	 */
	private JFrame parent;
	protected Object serverConnectFrame;
//	Panels
	/**
	 * 
	 * 
	 */
	protected JPanel ppalPanel = null;
	/**
	 * 
	 * 
	 */
	protected SearchUpperPanel upperPanel = null;
	/**
	 * 
	 * 
	 */
	protected SearchLowerPanel lowerPanel = null;
	/**
	 * 
	 * 
	 */
	protected JPanel checkBoxPanel = null;
	/**
	 * 
	 * 
	 */
	protected JPanel buttonsPanel = null;
//	Buttons
	/**
	 * 
	 * 
	 */
	private JButton searchButton = null;
	/**
	 * <p></p>
	 * 
	 * 
	 * 
	 * @poseidon-type es.gva.cit.catalogClient.metadataXML.XMLNode
	 */
	protected java.util.Collection nodes = new java.util.ArrayList();
	/**
	 * 
	 * 
	 */
	private JButton closeButton = null;
	/**
	 * 
	 * 
	 */
	private JButton cancelSearchesButton = null;
	/**
	 * 
	 * 
	 */
	private JButton returnButton = null;
	/**
	 * 
	 * 
	 */
	private JButton sizeButton = null;
	/**
	 * 
	 * 
	 */
	private JCheckBox areaCheckBox = null;
//	Otros
	/**
	 * 
	 * 
	 */
	protected CatalogClient client = null;

	/**
	 * 
	 * 
	 */
	protected boolean isMinimized = true;

	/**
	 * 
	 * 
	 */
	protected String currentServer = null;

	/**
	 * 
	 * 
	 */
	private Collection searchThreads = null;

	/**
	 * This method initializes
	 * 
	 * 
	 * @param parent 
	 * @param translator 
	 * @param client 
	 */
	public  SearchDialogPanel(JFrame parent, Object serverConnectFrame, CatalogClient client) {        
		super();
		searchThreads = new java.util.ArrayList();
		this.isMinimized = true;
		this.parent = parent;
		this.client = client;
		this.serverConnectFrame = serverConnectFrame;
		initialize();
	} 

	/**
	 * This method initializes this
	 * 
	 */
	protected void initialize() {        
		ppalPanel = null;
		ppalPanel = new JPanel();
		ppalPanel.setLayout(new BoxLayout(ppalPanel, BoxLayout.Y_AXIS));
		ppalPanel.setPreferredSize(new Dimension(514,150));
		ppalPanel.add(getUpperPanel());
		ppalPanel.add(getLowerPanel());        
		ppalPanel.add(getButtonsPanel());
		add(ppalPanel);
		setDefaultButtonListeners();

		getLowerPanel().setVisible(false);
		setVisible(true); 
		getUpperPanel().addServices(client.isServicesSeachSupported());

	} 

	/**
	 * It Gets the upperPanel
	 * 
	 * 
	 * @return 
	 */
	public SearchUpperPanel getUpperPanel() {        
		if (upperPanel == null){
			upperPanel = new SearchUpperPanel(client.getProtocol(),
					client.getLnkICatalogServerDriver().getQueryProfile(),
					this);  
		}
		return upperPanel;

	} 

	/**
	 * It Gets the lowePanel
	 * 
	 * 
	 * @return 
	 */
	public SearchLowerPanel getLowerPanel() {        
		if (lowerPanel == null){
			lowerPanel = new SearchLowerPanel(client.getProtocol(),
					client.getLnkICatalogServerDriver().getQueryProfile(),
					this);  

		}
		return lowerPanel;
	} 

	/**
	 * It gets the buttons panel
	 * 
	 * 
	 * @return 
	 */
	public JPanel getButtonsPanel() {        
		if (buttonsPanel == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setAlignment(FlowLayout.RIGHT);
			buttonsPanel = new JPanel(flowLayout);
			buttonsPanel.add(getSearchButton(), null);
			buttonsPanel.add(getCancelSearchesButton(), null);
			JLabel label = new JLabel();
			label.setPreferredSize(new Dimension(6,0));
			buttonsPanel.add(label, null);
			buttonsPanel.add(getReturnButton(), null);
			buttonsPanel.add(getCloseButton(), null);
		}
		return buttonsPanel;
	} 

	/**
	 * It gets the search button
	 * 
	 * 
	 * @return 
	 */
	public JButton getSearchButton() {        
		if (searchButton == null) {
			searchButton = new JButton(Messages.getText("searchButton"));
			searchButton.setPreferredSize(new Dimension(80, 23));
			searchButton.setActionCommand("search");
		}
		return searchButton;
	} 

	/**
	 * It gets the cancel searches button
	 * 
	 * 
	 * @return 
	 */
	public JButton getCancelSearchesButton() {        
		if (cancelSearchesButton == null) {
			cancelSearchesButton = new JButton(Messages.getText("cancelSearchButton"));
			cancelSearchesButton.setPreferredSize(new Dimension(90, 23));
			cancelSearchesButton.setActionCommand("cancel");
		}
		return cancelSearchesButton;
	} 

	/**
	 * It gets the close button
	 * 
	 * 
	 * @return 
	 */
	public JButton getCloseButton() {        
		if (closeButton == null) {
			closeButton = new JButton(Messages.getText("close"));
			closeButton.setPreferredSize(new Dimension(80, 23));
			closeButton.setActionCommand("close");
		}
		return closeButton;
	} 
	
	/**
	 * It gets the return button
	 * 
	 * 
	 * @return 
	 */
	public JButton getReturnButton() {        
		if (returnButton == null) {
			returnButton = new JButton(Messages.getText("last"));
			returnButton.setPreferredSize(new Dimension(80, 23));
			returnButton.setActionCommand("return");
		}
		return returnButton;
	} 

	/**
	 * It  gets the change size button
	 * 
	 * 
	 * @return 
	 */
	public JButton getSizeButton() {        
		if (sizeButton == null) {
			sizeButton = upperPanel.getSizeButton();
			sizeButton.setActionCommand("size");
		}
		return sizeButton;
	} 

	/**
	 * It gets the checkBox area component
	 * 
	 * 
	 * @return 
	 */
	public JCheckBox getAreaCheckBox() {        
		if (areaCheckBox == null){
			areaCheckBox = upperPanel.getCoordinatesCheckBox();
			areaCheckBox.setActionCommand("areaCheckButton");
		}
		return areaCheckBox;
	} 

	/**
	 * It sets the listeners
	 * 
	 */
	public void setDefaultButtonListeners() {        
		getSearchButton().addActionListener(this);
		getCloseButton().addActionListener(this);
		getSizeButton().addActionListener(this);
		getAreaCheckBox().addItemListener(this);
		getReturnButton().addActionListener(this);
		getCancelSearchesButton().addActionListener(this);
	} 

	/**
	 * 
	 * 
	 * 
	 * @param e 
	 */
	public void actionPerformed(ActionEvent e) {        
		//Buscar
		if (e.getActionCommand() == "search") {
			searchButtonActionPerformed();
		} 
		if (e.getActionCommand() == "close") {
			closeButtonActionPerformed();
		}
		if (e.getActionCommand() == "size") {
			sizeButtonActionPerformed();
		}             
		if (e.getActionCommand() == "cancel") {
			cancelSearchesButtonActionPerformed();
		} 		
		if (e.getActionCommand() == "return") {
			returnButtonActionPerformed();
		} 
	} 

	/**
	 * 
	 * 
	 */
	protected void sizeButtonActionPerformed() {        
		if (isMinimized){
			parent.resize(525,450);
			ppalPanel.setPreferredSize(new Dimension(514,423));
			getLowerPanel().setVisible(true);
			parent.setVisible(true);
			getUpperPanel().setUpIcon();
		}else{
			parent.setSize(525,113);
			ppalPanel.setPreferredSize(new Dimension(514,91));
			getLowerPanel().setVisible(false);
			ppalPanel.setVisible(true);
			getUpperPanel().setDownIcon();
		}
		isMinimized = !isMinimized;
	} 
	
	/**
	 * Return button
	 *
	 */
	protected void returnButtonActionPerformed() {        
		((JFrame)serverConnectFrame).setVisible(true);
		parent.setVisible(false);
	} 


	/**
	 * 
	 * 
	 */
	protected void searchButtonActionPerformed() {        
		searchThread st =  new searchThread();
		searchThreads.add(st);   
		setCursor(new Cursor(Cursor.WAIT_CURSOR));        
	} 

	/**
	 * 
	 * 
	 */
	protected void cancelSearchesButtonActionPerformed() {        
		for (int i=0 ; i<searchThreads.size() ; i++){
			searchThread st = (searchThread)searchThreads.toArray()[i];
			st.stop();            
		}     
		searchThreads.clear();
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));        
	} 

	/**
	 * 
	 * 
	 */
	protected void closeButtonActionPerformed() {        
		parent.setVisible(false);
	} 

	/**
	 * It returns the query that the user has selected
	 * 
	 * 
	 * @return 
	 */
	private Query doQuery() {        
		Query query = client.createNewQuery();
		query.setSearchType(upperPanel.getService());
		query.setTitle(upperPanel.getTitle());
		query.setTitleFilter(lowerPanel.getTitleOption());
		query.setAbstract(lowerPanel.getAbstract());
		query.setThemeKey(lowerPanel.getKeys());
		query.setTopic(lowerPanel.getCathegory());
		query.setScale(lowerPanel.getScale());
		query.setProvider(lowerPanel.getProvider());
		query.setDateFrom(lowerPanel.getDateFrom());
		query.setDateTo(lowerPanel.getDateTo());
		query.setCoordenates(lowerPanel.getCoordinates());
		query.setCoordenatesFilter(lowerPanel.getCoordinatesOption());
		query.setMinimized(isMinimized);
		query.setCoordinatesClicked(upperPanel.getRestrictAreaClicked());

		if (isMinimized){
			query.setTitleFilter("E");
		}        
		return query;
	} 

	/**
	 * This method realizes the search
	 * 
	 */
	private void doSearch() {        
		nodes = client.getRecords(client.getUrl(),
				doQuery(), 1);
		if (nodes == null) {
			JOptionPane.showMessageDialog(this,
					Messages.getText("errorGetRecords"),
					"Error",
					JOptionPane.ERROR_MESSAGE);
		} else if (nodes.size() == 1) {
			JOptionPane.showMessageDialog(this,
					Messages.getText("anyResult"),
					Messages.getText("catalog_search"),
					JOptionPane.INFORMATION_MESSAGE);
		}
	} 

	/**
	 * This methos calls to present results form
	 * 
	 * 
	 * @param nodes 
	 */
	protected void showResults(Collection nodes) {        
		new ShowResultsDialog(client, nodes, 1);
	} 
	/* (non-Javadoc)
	 * @see java.awt.event.ItemListener#itemStateChanged(java.awt.event.ItemEvent)
	 * This methodhave to be implemented in gvSIG to load the bbox to o the search
	 */

	/**
	 * 
	 * 
	 * 
	 * @param e 
	 */
	public void itemStateChanged(ItemEvent e) {        


	} 

	/**
	 * 
	 * 
	 * 
	 * @param isMinimized The isMinimized to set.
	 */
	public void setMinimized(boolean isMinimized) {        
		this.isMinimized = isMinimized;
	} 

	/**
	 * 
	 * 
	 * 
	 * @return Returns the currentServer.
	 */
	public String getCurrentServer() {        
		return currentServer;
	} 

	/**
	 * 
	 * 
	 * 
	 * @param currentServer The currentServer to set.
	 */
	public void setCurrentServer(String currentServer) {        
		this.currentServer = currentServer;
	} 

	/**
	 * 
	 * 
	 * 
	 * @param parent The parent to set.
	 */
	public void setParent(JFrame parent) {        
		this.parent = parent;
	} 
	
	/**
	 * This method enable or disables the components depending
	 * of the selected service 
	 * @param service
	 * Selected service
	*/
	public void disableComponents(String service) { 
		if (service.equals(Messages.getText("services"))){
			getUpperPanel().disableAllComponents();
			getLowerPanel().disableAllComponents();
		}else{
			getUpperPanel().enableAllComponents();
			getLowerPanel().enableAllComponents();
			getUpperPanel().disableComponents(client.getProtocol(),
					client.getLnkICatalogServerDriver().getQueryProfile());
			getLowerPanel().disableComponents(client.getProtocol(),
					client.getLnkICatalogServerDriver().getQueryProfile());
		}
				
	} 
	/**
	 * This class is used to manage the searches.
	 * It contains method to start and to stop a thread. It is
	 * necessary to create because "stop" method (for the Thread class)
	 * is deprecated.
	 * 
	 * 
	 * @author Jorge Piera Llodra (piera_jor@gva.es)
	 */
	private class searchThread implements Runnable {

		/**
		 * 
		 * 
		 */
		volatile Thread myThread = null;

		/**
		 * 
		 * 
		 */
		public  searchThread() {        
			myThread = new Thread(this);
			myThread.start();
		} 

		/**
		 * 
		 * 
		 */
		public void stop() {        
			myThread.stop();
		} 

		/**
		 * 
		 * 
		 */
		public void run() {        
			doSearch();
			if ((nodes != null) && (nodes.size() > 1)) {
				showResults(nodes);
			}
			searchThreads.remove(this);
			if (searchThreads.size() == 0){
				setCursor(new Cursor(Cursor.DEFAULT_CURSOR));       
			}
		} 
	}
}
