/*
 * Created on 17-feb-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Iterator;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

import org.cresques.geo.ViewPortData;
import org.cresques.io.GeoRasterWriter;
import org.cresques.io.IDataWriter;
import org.cresques.io.data.RasterBuf;
import org.cresques.px.Extent;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.plugins.Extension;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.project.Project;
import com.iver.cit.gvsig.project.documents.view.gui.View;
import com.sun.jimi.core.Jimi;
import com.sun.jimi.core.JimiException;


/**
 * Extensin para exportar en algunos formatos raster la vista actual.
 *
 * @author Fernando Gonzlez Corts
 */
public class Export extends Extension {
	private String lastPath = null;
	private Hashtable cmsExtensionsSupported = null; 
	private Hashtable jimiExtensionsSupported = null;

	/**
	 * @see com.iver.andami.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
		View f = (View) PluginServices.getMDIManager().getActiveWindow();

		if (f == null) {
			return false;
		}

		FLayers layers = f.getModel().getMapContext().getLayers();
		for (int i=0;i< layers.getLayersCount();i++) {
			return layers.getLayer(i).isAvailable();
		}
		return false;
	}

	/**
	 * @see com.iver.mdiApp.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		com.iver.andami.ui.mdiManager.IWindow f = (com.iver.andami.ui.mdiManager.IWindow) PluginServices.getMDIManager()
																								  .getActiveWindow();

		if (f == null) {
			return false;
		}

		return (f instanceof View);
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
	}

	/* (non-Javadoc)
	 * @see com.iver.andami.plugins.Extension#postInitialize()
	 */
	public void postInitialize() {
		cmsExtensionsSupported = new Hashtable(); 
		jimiExtensionsSupported = new Hashtable();
		
//		String[] ext;
//		ext = GeoRasterWriter.getDriversExtensions(); 
//		int i;
//		for (i=0;i< ext.length;i++){
//			cmsExtensionsSupported.put(ext[i], new MyFileFilter(ext[i],
//					PluginServices.getText(this, ext[i]), "cms"));
//		}
		
		cmsExtensionsSupported.put("jpg", new MyFileFilter("jpg",
				PluginServices.getText(this, "jpg"), "cms"));
		
//		ext = Jimi.getEncoderTypes();
//		for (i=0;i<ext.length;i++){
//			if (!cmsExtensionsSupported.contains( ext[i])) {
//				jimiExtensionSupported.put(ext[i], new GenericFileFilter(ext[i],
//						PluginServices.getText(this, ext[i])));
//			}
//		}
		
		jimiExtensionsSupported.put("png",new MyFileFilter("png",
				PluginServices.getText(this, "png"), "jimi"));
		jimiExtensionsSupported.put("bmp",new MyFileFilter("bmp",
				PluginServices.getText(this, "bmp"), "jimi"));		
//		jimiExtensionsSupported.put("tga",new MyFileFilter("tga",
//				PluginServices.getText(this, "tga"), "jimi"));


		
		
		
	}

	public static boolean saveImageCMS(File fileDst,BufferedImage srcImage) throws IOException{
		RasterizerImage data = new RasterizerImage(srcImage);
		Extent ex = new Extent(0,0,srcImage.getWidth(),srcImage.getHeight());
		ViewPortData vpData = new ViewPortData(Project.getDefaultProjection(), ex, new Dimension(srcImage.getWidth(),srcImage.getHeight()));
		GeoRasterWriter writer = GeoRasterWriter.getWriter(data,fileDst.getAbsolutePath(),srcImage.getHeight(),3,vpData,10,srcImage.getWidth(),srcImage.getHeight(),RasterBuf.TYPE_IMAGE);
		writer.setWriteTfw(false);
		if (writer == null){
			PluginServices.getLogger().error("No supported Format: " + fileDst.getAbsolutePath());
			return false;
		}
		writer.dataWrite();
		writer.writeClose(); 
		return true;
	}
	
	
	
	public static boolean saveImageJimi(File fileDst,BufferedImage srcImage) throws Exception{
		try {

			Jimi.putImage(srcImage, fileDst.getAbsolutePath());
			
		} catch (JimiException e) {
			throw new Exception(fileDst.getAbsolutePath(),e);
		}
		return true;

	}
	
	/**
	 * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
	 */
	public void execute(String actionCommand) {
		JFileChooser jfc = new JFileChooser(lastPath);
		
		jfc.removeChoosableFileFilter(jfc.getAcceptAllFileFilter());
		
		Iterator iter;
		
		iter = cmsExtensionsSupported.values().iterator();
		while (iter.hasNext()){
			jfc.addChoosableFileFilter((FileFilter)iter.next());
		}

		iter = jimiExtensionsSupported.values().iterator();
		while (iter.hasNext()){
			jfc.addChoosableFileFilter((FileFilter)iter.next());
		}

		jfc.setFileFilter((FileFilter)jimiExtensionsSupported.get("png"));
		if (jfc.showSaveDialog(
				(Component) PluginServices.getMainFrame()
				) == JFileChooser.APPROVE_OPTION) {
			BufferedImage tempImage;

			tempImage = ((View) PluginServices.getMDIManager().getActiveWindow()).getImage();

			File f = jfc.getSelectedFile();
			
			lastPath = f.getParent();
			
			MyFileFilter filter = (MyFileFilter)jfc.getFileFilter();
			f = filter.normalizeExtension(f);
			
			
			if (f.exists()){
				int resp = JOptionPane.showConfirmDialog(
						(Component) PluginServices.getMainFrame(),
						PluginServices.getText(this,
								"fichero_ya_existe_seguro_desea_guardarlo")+
								"\n"+ 
								f.getAbsolutePath(),
						PluginServices.getText(this,"guardar"), JOptionPane.YES_NO_OPTION);
				if (resp != JOptionPane.YES_OPTION) {
					return;
				}

			}
			
			if (filter.getInfo().equalsIgnoreCase("cms")){
				
				try {
					saveImageCMS(f, tempImage);
				} catch (IOException e) {
					NotificationManager.addError("Error exportando la imagen", e);
				}
			} else if (filter.getInfo().equalsIgnoreCase("jimi")) {
				try {
					saveImageJimi(f, tempImage);
				} catch (Exception e) {
					NotificationManager.addError("Error exportando la imagen", e);
				}
				
			}

			
		}
	}
}

class RasterizerImage implements IDataWriter{
	private BufferedImage source;
	private int[] data = null;
	
	public RasterizerImage(BufferedImage source) {
		this.source = source;
	}

	public int[] readARGBData(int sX, int sY, int nBand){
		return readData( sX, sY, nBand);
	}
	
	public int[] readData(int sizeX, int sizeY, int nBand) {
		if(nBand == 0){ //Con nBand==0 se devuelven las 3 bandas
			if (this.data == null){					
				this.data = this.source.getRGB(0, 0, sizeX, sizeY, this.data, 0, sizeX);
			}
			return this.data;
		}
		return null;
	}

	public byte[][] readByteData(int arg0, int arg1) {
		// TODO Auto-generated method stub
		return null;
	}

	public double[][] readDoubleData(int arg0, int arg1) {
		// TODO Auto-generated method stub
		return null;
	}

	public float[][] readFloatData(int arg0, int arg1) {
		// TODO Auto-generated method stub
		return null;
	}

	public int[][] readIntData(int arg0, int arg1) {
		// TODO Auto-generated method stub
		return null;
	}

	public short[][] readShortData(int arg0, int arg1) {
		// TODO Auto-generated method stub
		return null;
	}
	
}

class MyFileFilter extends FileFilter{

	private String[] extensiones=new String[1];
	private String description;
	private boolean dirs = true;
	private String info= null;

	public MyFileFilter(String[] ext, String desc) {
		extensiones = ext;
		description = desc;
	}

	public MyFileFilter(String[] ext, String desc,String info) {
		extensiones = ext;
		description = desc;
		this.info = info;
	}

	public MyFileFilter(String ext, String desc) {
		extensiones[0] = ext;
		description = desc;
	}

	public MyFileFilter(String ext, String desc,String info) {
		extensiones[0] = ext;
		description = desc;
		this.info = info;
	}

	public MyFileFilter(String ext, String desc, boolean dirs) {
		extensiones[0] = ext;
		description = desc;
		this.dirs = dirs;
	}

	public MyFileFilter(String ext, String desc, boolean dirs,String info) {
		extensiones[0] = ext;
		description = desc;
		this.dirs = dirs;
		this.info = info;
	}

	public boolean accept(File f) {
		if (f.isDirectory()) {
			if (dirs) {
				return true;
			} else {
				return false;
			}
		}
		for (int i=0;i<extensiones.length;i++){
			if (extensiones[i].equals("")){
				continue;
			}
			if (getExtensionOfAFile(f).equalsIgnoreCase(extensiones[i])){
				return true;
			}
		}
		
		return false;
	}

	/**
	 * @see javax.swing.filechooser.FileFilter#getDescription()
	 */
	public String getDescription() {
		return description;
	}

	public String[] getExtensions() {
		return extensiones;
	}
	
	public boolean isDirectory(){
		return dirs;
	}
	
	private String getExtensionOfAFile(File file){
		String name;
		int dotPos;
		name = file.getName();
		dotPos = name.lastIndexOf(".");
		if (dotPos < 1){
			return "";
		}
		return name.substring(dotPos+1);
	}
	
	public File normalizeExtension(File file){
		String ext = getExtensionOfAFile(file);
		if (ext.equals("") || !(this.accept(file))){
			return new File(file.getAbsolutePath() + "." + extensiones[0]);
		}
		return file;		
	}
	
	public String getInfo(){
		return this.info;
	}
	
	public void setInfo(String info){
		this.info = info;
	}

}