/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import org.apache.log4j.Logger;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.project.documents.layout.FLayoutFunctions;


/**
 * Extensin para editar los vrtices de las geometras aadidas en un FFrameGraphics.
 *
 * @author Vicente Caballero Navarro
 */
public class LayoutInsertToolsExtension extends Extension {
    private static Logger logger = Logger.getLogger(LayoutInsertToolsExtension.class.getName());
    private Layout layout = null;


    public void initialize() {
		// TODO Auto-generated method stub
	}


    public void execute(String s) {
    	 layout = (Layout) PluginServices.getMDIManager().getActiveWindow();

         logger.debug("Comand : " + s);
         boolean insertGroupPosibility=false;
         if (s.equals("SELECT")) {
             layout.setTool(Layout.SELECT);
         } else if (s.equals("RECTANGLEVIEW")) {
     		layout.setTool(Layout.RECTANGLEVIEW);
     		insertGroupPosibility=true;
     	} else if (s.equals("RECTANGLEPICTURE")) {
     		layout.setTool(Layout.RECTANGLEPICTURE);
     		insertGroupPosibility=true;
     	} else if (s.equals("RECTANGLESCALEBAR")) {
     		layout.setTool(Layout.RECTANGLESCALEBAR);
     		insertGroupPosibility=true;
     	} else if (s.equals("RECTANGLELEGEND")) {
     		layout.setTool(Layout.RECTANGLELEGEND);
     		insertGroupPosibility=true;
     	} else if (s.equals("RECTANGLETEXT")) {
     		layout.setTool(Layout.RECTANGLETEXT);
     		insertGroupPosibility=true;
     	} else if (s.equals("RECTANGLENORTH")) {
     		layout.setTool(Layout.RECTANGLENORTH);
     		insertGroupPosibility=true;
     	} else if (s.equals("RECTANGLEBOX")) {
     		layout.setTool(Layout.RECTANGLEBOX);
     		insertGroupPosibility=true;
     	} else if (s.equals("POINT")) {
     		layout.setTool(Layout.POINT);
     	} else if (s.equals("LINE")) {
     		layout.setTool(Layout.LINE);
     	} else if (s.equals("POLYLINE")) {
     		layout.setTool(Layout.POLYLINE);
     	} else if (s.equals("CIRCLE")) {
     		layout.setTool(Layout.CIRCLE);
     	} else if (s.equals("RECTANGLESIMPLE")) {
     		layout.setTool(Layout.RECTANGLESIMPLE);
     	} else if (s.equals("POLYGON")) {
     		layout.setTool(Layout.POLYGON);
     	} else if (s.equals("REMOVE")){
     		layout.delFFrameSelected();
     		layout.refresh();
     	}
         if (layout.isEditGroup() && insertGroupPosibility){
         	FLayoutFunctions funtions=new FLayoutFunctions(layout);
         	funtions.addFFrame();
         }
   }


    public boolean isEnabled() {
    	IWindow f = PluginServices.getMDIManager().getActiveWindow();

        if (f == null) {
            return false;
        }

        if (f instanceof Layout) {
            return ((Layout) f).isEditable();
        }

        return false;
	}


    public boolean isVisible() {
		IWindow f = PluginServices.getMDIManager().getActiveWindow();

		if (f == null) {
			return false;
		}

		if (f instanceof Layout) {
			return true;
		} else {
			return false;
		}
	}
}
