/*
 * Created on 31-ene-2005
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.project.documents.view.legend.scale.gui;

import java.awt.BorderLayout;
import java.awt.geom.Rectangle2D;
import java.text.NumberFormat;

import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import org.apache.log4j.Logger;

import com.hardcode.gdbms.engine.data.DataSource;
import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.drivers.DBLayerDefinition;
import com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrDefault;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.fmap.layers.ReadableVectorial;
import com.iver.cit.gvsig.fmap.layers.VectorialAdapter;
import com.iver.cit.gvsig.fmap.layers.VectorialDBAdapter;
import com.iver.cit.gvsig.fmap.layers.VectorialFileAdapter;
import com.iver.cit.gvsig.fmap.layers.layerOperations.AlphanumericData;
import com.iver.cit.gvsig.fmap.rendering.Legend;
import com.iver.cit.gvsig.fmap.rendering.VectorialUniqueValueLegend;
import com.iver.cit.gvsig.project.documents.view.IProjectView;
import com.iver.cit.gvsig.project.documents.view.legend.gui.AbstractPanel;
import com.iver.cit.gvsig.project.documents.view.legend.gui.FPanelLegendValues;
/**
 * @author jmorell
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class FPanelScaleManager extends AbstractPanel {

	private static final long serialVersionUID = 1L;
    private static Logger logger = Logger.getLogger(FPanelLegendValues.class.getName());
	private FLayer layer;
    //private ComandosListener actionListener = new ComandosListener(this);
	private IProjectView view;
	private NumberFormat nf = NumberFormat.getInstance();

	private JPanel jPanel = null;
	private JPanel jPanel1 = null;
	private JPanel jPanel2 = null;
	private JPanel jPanel4 = null;
	private JPanel jPanel5 = null;
	private JLabel jLabel = null;
	private JTextField txtLayerName = null;
	private JLabel jLabel1 = null;
	private JTextField jTextField1 = null;
	private JLabel jLabel2 = null;
	private JTextArea jTextArea = null;
	private JScrollPane jScrollPane = null;
	private ButtonGroup buttonGroup = null;
	private JRadioButton jRadioButton = null;
	private JRadioButton jRadioButton1 = null;
	private JLabel jLabel3 = null;
	private JTextField jTextField2 = null;
	private JLabel jLabel4 = null;
	private JPanel jPanel3 = null;
    private JPanel jPanel6 = null;
    private JPanel jPanel7 = null;
    private JPanel jPanel8 = null;
    private JLabel jLabel5 = null;
    private JComboBox jComboBox = null;
    private JLabel jLabel6 = null;
    private JTextField jTextField = null;
    private JLabel jLabel7 = null;
    private JComboBox jComboBox1 = null;
    private JCheckBox jCheckBoxSpatialIndex = null;
    /**
	 * This is the default constructor
	 */
	public FPanelScaleManager() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private  void initialize() {
		//setView();
		this.setLayout(null);
		//this.setLayer(null);
		this.setBounds(0, 0, 635, 352);
		this.add(getJCheckBoxSpatialIndex(), null);
		this.add(getJPanel(), null);
		this.add(getJPanel1(), null);
		this.add(getJPanel2(), null);
		this.add(getJPanel3(), null);
	}


    /**
     * Inicializa el ProjectView view. Es necesario para implementar el control de
     * escalas y para hiperenlazar documentos.
     * @return
     */
    /*private void setView() {
		View vista = (View) PluginServices.getMDIManager().getActiveView();
    	view = vista.getModel();
    }*/

    /**
     * En esta funcin se coge el primer tema activo del TOC y se usa su
     * renderer para inicializar. Hay que llamarla SIEMPRE que se abra el
     * cuadro de dilogo, en el  openLegendManager() de la vista.
     *
     * @param mapContext TOC que abre este cuadro de dilogo.
     * @throws DriverException
     */
    public void setMapContext(MapContext mapContext) throws DriverException {
        layer = getFirstActiveLayerVect(mapContext.getLayers());
       	/*try {
				ClassifiableVectorial aux = (ClassifiableVectorial) layer;
				renderer = (Legend) aux.getLegend().cloneLegend();
			} catch (XMLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}*/
        actualizar();
    }

    /**
     * DOCUMENT ME!
     */
    private void actualizar() {
    	// Avisar si no es Vectorial
    	//FLayer lyrSelected = getFirstActiveLayerVect(mapContext.getLayers());

        /*m_defaultLegendPanel.setLayer(lyrSelected, renderer);
        m_valuesLegendPanel.setLayer(lyrSelected, renderer);
        m_breaksLegendPanel.setLayer(lyrSelected, renderer);
        m_labelsLegendPanel.setLayer(lyrSelected, renderer);*/

        /*CardLayout cl = (CardLayout)(cards.getLayout());
        if (renderer instanceof SingleSymbolLegend) {
        	//organizador.setSelectedIndex(0);
            cl.show(cards, "symbol");
        }
        if (renderer instanceof UniqueValueLegend) {
        	//organizador.setSelectedIndex(1);
            cl.show(cards, "values");
        }
        if (renderer instanceof IntervalLegend) {
        	//organizador.setSelectedIndex(2);
            cl.show(cards, "intervals");
        }*/

        /* switch (m_Renderer.getLegendType()) {
        case FConstant.LEGEND_TYPE_DEFAULT:
            organizador.setSelectedIndex(0);

            break;

        case FConstant.LEGEND_TYPE_VALUE:
            organizador.setSelectedIndex(1);

            break;

        case FConstant.LEGEND_TYPE_BREAK:
            organizador.setSelectedIndex(2);

            break;
        } */
    }

	private void fillFieldNames() {
		DataSource rs;
		try {
			rs = ((AlphanumericData)layer).getRecordset();
			logger.debug("rs.start()");
			rs.start();
			String[] nomFields = new String[rs.getFieldCount()];
			for (int i = 0; i < rs.getFieldCount(); i++) {
				nomFields[i] = rs.getFieldName(i).trim();
			}
			rs.stop();
		// fieldsListValor.setSelectedIndex(0);
		} catch (com.hardcode.gdbms.engine.data.driver.DriverException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (DriverException e) {
			e.printStackTrace();
		}
	}

	public void setLayer(FLayer lyr, Legend r) {
        if (lyr instanceof FLyrVect)
        {
            FLyrVect lyrVect = (FLyrVect) lyr;
//            if (lyrVect.getSpatialIndex() == null)//azabala
            if(lyrVect.getISpatialIndex() == null)
            {
                getJCheckBoxSpatialIndex().setSelected(false);
            }
            else
            {
                getJCheckBoxSpatialIndex().setSelected(true);
            }
        }
		if (layer.getMinScale() != -1)
		    getJTextField1().setText(nf.format(layer.getMinScale()));
		if (layer.getMaxScale() != -1)
		    getJTextField2().setText(nf.format(layer.getMaxScale()));
		if (layer.getMinScale() == -1 && layer.getMaxScale() == -1) {
			getJRadioButton().setSelected(true);
			jLabel1.setEnabled(false);
			jTextField1.setEnabled(false);
			jLabel2.setEnabled(false);
			jLabel3.setEnabled(false);
			jTextField2.setEnabled(false);
			jLabel4.setEnabled(false);
		} else {
			getJRadioButton1().setSelected(true);
			jLabel1.setEnabled(true);
			jTextField1.setEnabled(true);
			jLabel2.setEnabled(true);
			jLabel3.setEnabled(true);
			jTextField2.setEnabled(true);
			jLabel4.setEnabled(true);
		}
		fillFieldNames();
		//getJComboBox().getModel().setSelectedItem(renderer.getFieldName());
		layer = lyr;
		txtLayerName.setText(layer.getName());
		showLayerInfo();
		/*
		try {
			getJTextArea().setText(PluginServices.getText(this,"Extent") + "\n\t" + PluginServices.getText(this,"Superior") + ":\t" + layer.getFullExtent().getMaxY() + "\n\t" + PluginServices.getText(this,"Inferior") + ":\t" + layer.getFullExtent().getMinY() + "\n\t" + PluginServices.getText(this,"Izquierda") + ":\t" + layer.getFullExtent().getMinX() + "\n\t" + PluginServices.getText(this,"Derecha") + ":\t" + layer.getFullExtent().getMaxX() + "\n\n" + PluginServices.getText(this,"Origen_de_datos") + ": " + layer.getName());
		} catch (DriverException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		*/

        // Me parece que es aqu donde hay que montar el jComboBox ...
		if (PluginServices.getMainFrame() != null)
		if  (PluginServices.getMDIManager().getActiveWindow() instanceof com.iver.cit.gvsig.project.documents.view.gui.BaseView ){
		    com.iver.cit.gvsig.project.documents.view.gui.BaseView theView = (com.iver.cit.gvsig.project.documents.view.gui.BaseView)PluginServices.getMDIManager().getActiveWindow();
		    view = theView.getModel();
            try {
                if (layer instanceof AlphanumericData) {
                    AlphanumericData ad = (AlphanumericData) layer;
                    DataSource ds;
                    ds = ad.getRecordset();
                    String[] names = new String[ds.getFieldCount()];
                    for (int i = 0; i < ds.getFieldCount(); i++) {
                        names[i] = ds.getFieldName(i);
                    }
                    //jComboBox = new javax.swing.JComboBox(names);
                    DefaultComboBoxModel defaultModel = new DefaultComboBoxModel(names);
                    jComboBox.setModel(defaultModel);
                    if (view.getSelectedField() != null) {
                        jComboBox.setSelectedItem(view.getSelectedField());
                    }
                }else{
                    jComboBox = new javax.swing.JComboBox();
                }
            } catch (DriverException e) {
                NotificationManager.addError("No se pudo obtener la tabla", e);
            } catch (com.hardcode.gdbms.engine.data.driver.DriverException e) {
                NotificationManager.addError("No se pudo obtener la tabla", e);
            }
            //

            // y aqu el jTextField ...
            if (view.getSelectedField() != null) {
                getJTextField().setText(view.getExtLink());
            }
            //

            // y aqu el jComboBox1 ...
            //jComboBox1 = new javax.swing.JComboBox();
            getJComboBox1().addItem(PluginServices.getText(this,
                    "Enlazar_a_ficheros_de_imagen"));
            getJComboBox1().addItem(PluginServices.getText(this,
            "Enlazar_a_fichero_de_texto"));
            if (view.getSelectedField() != null) {
                getJComboBox1().setSelectedIndex(view.getTypeLink());
            }
            //
        }
		// Si es de valor nico, rellenamos la tabla
		// y seleccionamos el campo que estamos usando
		//m_symbolTable.removeAllItems();
		if (r instanceof VectorialUniqueValueLegend)
		{
			//renderer = (VectorialUniqueValueLegend) r;
			//m_cboFields.getModel().setSelectedItem(m_Renderer.getFieldName());
			//m_symbolTable.fillTableFromSymbolList(m_Renderer.getSymbols(),
					//m_Renderer.getValues(), m_Renderer.getDescriptions());
		}
		/*else
		{
			try {
				// Si la capa viene con otro tipo de leyenda, creamos
				// una nueva del tipo que maneja este panel
				renderer = new VectorialUniqueValueLegend(layer.getShapeType());
			} catch (com.iver.cit.gvsig.fmap.DriverException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}*/
	}

	/*public void setLayerName(String layerName)
	{
		this.layerName = layerName;
	}*/

	/**
	 * This method initializes jPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jLabel = new JLabel();
			jPanel = new JPanel();
			jPanel.setLayout(null);
			jLabel.setText(PluginServices.getText(this,"Nombre") + ":");
			jLabel.setComponentOrientation(java.awt.ComponentOrientation.UNKNOWN);
			jLabel.setBounds(0, 3, 78, 15);
			jPanel.setComponentOrientation(java.awt.ComponentOrientation.UNKNOWN);
			jPanel.setLocation(5, 6);
			jPanel.setSize(357, 20);
			jPanel.add(jLabel, null);
			jPanel.add(getTxtLayerName(), null);
		}
		return jPanel;
	}
	/**
	 * This method initializes jPanel1
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(null);
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, PluginServices.getText(this,"rango_de_escalas"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			jPanel1.setBounds(5, 61, 432, 137);
			jPanel1.add(getJPanel4(), null);
			jPanel1.add(getJPanel5(), null);
		}
		return jPanel1;
	}
	/**
	 * This method initializes jPanel2
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel2() {
		if (jPanel2 == null) {
			jPanel2 = new JPanel();
			jPanel2.setLayout(null);
			jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, PluginServices.getText(this,"propiedades"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			jPanel2.setBounds(5, 196, 303, 155);
			jPanel2.add(getJScrollPane(), null);
		}
		return jPanel2;
	}
	/**
	 * This method initializes jPanel4
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new JPanel();
			jPanel4.setLayout(null);
			jPanel4.setBounds(6, 21, 398, 46);
			jPanel4.add(getJRadioButton(), null);
			jPanel4.add(getJRadioButton1(), null);
			buttonGroup = new ButtonGroup();
			buttonGroup.add(getJRadioButton());
			buttonGroup.add(getJRadioButton1());
		}
		return jPanel4;
	}
	/**
	 * This method initializes jPanel5
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanel5() {
		if (jPanel5 == null) {
			jLabel4 = new JLabel();
			jLabel3 = new JLabel();
			jLabel2 = new JLabel();
			jLabel1 = new JLabel();
			jPanel5 = new JPanel();
			jPanel5.setLayout(null);
			jLabel1.setText(PluginServices.getText(this,"este_por_debajo_de_"));
			jLabel1.setBounds(6, 6, 138, 20);
			jLabel1.setEnabled(false);
			jLabel2.setText("(" + PluginServices.getText(this,"escala_minima") + ")");
			jLabel2.setBounds(302, 6, 111, 20);
			jLabel2.setEnabled(false);
			jPanel5.setBounds(15, 69, 414, 53);
			jLabel3.setBounds(6, 31, 138, 20);
			jLabel3.setText(PluginServices.getText(this,"este_por_encima_de"));
			jLabel3.setEnabled(false);
			jLabel4.setBounds(302, 31, 111, 20);
			jLabel4.setText("(" + PluginServices.getText(this,"escala_maxima") + ")");
			jLabel4.setEnabled(false);
			jPanel5.add(jLabel1, null);
			jPanel5.add(getJTextField1(), null);
			jPanel5.add(jLabel2, null);
			jPanel5.add(jLabel3, null);
			jPanel5.add(getJTextField2(), null);
			jPanel5.add(jLabel4, null);
		}
		return jPanel5;
	}
	/**
	 * This method initializes jTextField
	 *
	 * @return javax.swing.JTextField
	 */
	private JTextField getTxtLayerName() {
		if (txtLayerName == null) {
			//System.out.println("getJTestField(): layer = " + layer);
			//layerName = layer.getName();
			txtLayerName = new JTextField();
			//jTextField.setText(layerName);
			txtLayerName.setEditable(true);
			txtLayerName.setBounds(80, 0, 229, 20);
		}
		return txtLayerName;
	}
	/**
	 * This method initializes jTextField1
	 *
	 * @return javax.swing.JTextField
	 */
	public JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setBounds(147, 6, 152, 20);
			jTextField1.setEnabled(false);
		}
		return jTextField1;
	}
	/**
	 * This method initializes jTextArea
	 *
	 * @return javax.swing.JTextArea
	 */
	private JTextArea getJTextArea() {
		if (jTextArea == null) {
			jTextArea = new JTextArea();
			jTextArea.setEditable(false);
			jTextArea.setBackground(java.awt.SystemColor.control);
			//jTextArea.setText("Extent\n\tSuperior\n\tInferior\n\tIzquierda\n\tDerecha\n\nOrigen de datos\n\n... y movidas ...");
		}
		return jTextArea;
	}

	/*public void setLayer(FLayer layer) {
		this.layer = layer;
	}*/
	/**
	 * This method initializes jScrollPane
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setViewportView(getJTextArea());
			jScrollPane.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
			jScrollPane.setPreferredSize(new java.awt.Dimension(100,100));
			jScrollPane.setBounds(6, 21, 283, 120);
		}
		return jScrollPane;
	}
	/**
	 * This method initializes jRadioButton
	 *
	 * @return javax.swing.JRadioButton
	 */
	public JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			jRadioButton = new JRadioButton();
			jRadioButton.setText(PluginServices.getText(this,"Mostrar_siempre"));
			jRadioButton.setBounds(0, 0, 301, 23);
			jRadioButton.setSelected(true);
			jRadioButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					//jPanel5.setEnabled(false);
					jLabel1.setEnabled(false);
					jTextField1.setEnabled(false);
					jLabel2.setEnabled(false);
					jLabel3.setEnabled(false);
					jTextField2.setEnabled(false);
					jLabel4.setEnabled(false);
				}
			});
		}
		return jRadioButton;
	}
	/**
	 * This method initializes jRadioButton1
	 *
	 * @return javax.swing.JRadioButton
	 */
	public JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			jRadioButton1 = new JRadioButton();
			jRadioButton1.setText(PluginServices.getText(this,"No_mostrar_la_capa_cuando_la_escala"));
			jRadioButton1.setBounds(0, 23, 301, 23);
			jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					//jPanel5.setEnabled(true);
					jLabel1.setEnabled(true);
					jTextField1.setEnabled(true);
					jLabel2.setEnabled(true);
					jLabel3.setEnabled(true);
					jTextField2.setEnabled(true);
					jLabel4.setEnabled(true);
				}
			});
		}
		return jRadioButton1;
	}
	/**
	 * This method initializes jTextField2
	 *
	 * @return javax.swing.JTextField
	 */
	public JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
			jTextField2.setBounds(147, 31, 152, 20);
			jTextField2.setEnabled(false);
		}
		return jTextField2;
	}
	public String getLayerName(){
		return txtLayerName.getText().toString();
	}
    /**
     * This method initializes jPanel3
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel3() {
    	if (jPanel3 == null) {
    		jPanel3 = new JPanel();
    		jPanel3.setLayout(null);
    		jPanel3.setBounds(315, 195, 313, 154);
    		jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.LOWERED), PluginServices.getText(this, "Hiperenlace"), javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
    		jPanel3.add(getJPanel6(), null);
    	}
    	return jPanel3;
    }
    /**
     * This method initializes jPanel6
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel6() {
    	if (jPanel6 == null) {
    		jPanel6 = new JPanel();
    		jPanel6.setLayout(new BorderLayout());
    		jPanel6.setBounds(7, 22, 298, 119);
    		jPanel6.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
    		jPanel6.add(getJPanel7(), java.awt.BorderLayout.NORTH);
    		jPanel6.add(getJPanel8(), java.awt.BorderLayout.CENTER);
    	}
    	return jPanel6;
    }
    /**
     * This method initializes jPanel7
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel7() {
    	if (jPanel7 == null) {
    		jLabel6 = new JLabel();
    		jLabel6.setText(PluginServices.getText(this,"extension"));
    		jLabel5 = new JLabel();
    		jLabel5.setText(PluginServices.getText(this, "Campo") + "   ");
    		jPanel7 = new JPanel();
    		jPanel7.add(jLabel5, null);
    		jPanel7.add(getJComboBox(), null);
    		jPanel7.add(jLabel6, null);
    		jPanel7.add(getJTextField(), null);
    	}
    	return jPanel7;
    }
    /**
     * This method initializes jPanel8
     *
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel8() {
    	if (jPanel8 == null) {
    		jLabel7 = new JLabel();
    		jLabel7.setText(PluginServices.getText(this, "Accion_Predefinida") + "  ");
    		jPanel8 = new JPanel();
    		jPanel8.add(jLabel7, null);
    		jPanel8.add(getJComboBox1(), null);
    	}
    	return jPanel8;
    }
    /**
     * This method initializes jComboBox
     *
     * @return javax.swing.JComboBox
     */
    private JComboBox getJComboBox() {
    	if (jComboBox == null) {
            jComboBox = new JComboBox();
    	}
    	return jComboBox;
    }
    /**
     * This method initializes jTextField
     *
     * @return javax.swing.JTextField
     */
    private JTextField getJTextField() {
    	if (jTextField == null) {
    		jTextField = new JTextField();
            jTextField.setPreferredSize(new java.awt.Dimension(40,20));
    	}
    	return jTextField;
    }
    /**
     * This method initializes jComboBox1
     *
     * @return javax.swing.JComboBox
     */
    private JComboBox getJComboBox1() {
    	if (jComboBox1 == null) {
    		jComboBox1 = new JComboBox();
    	}
    	return jComboBox1;
    }
    /**
     * @return Returns the view.
     */
    public IProjectView getView() {
        return view;
    }
    /**
     * This method initializes jCheckBox
     *
     * @return javax.swing.JCheckBox
     */
    private JCheckBox getJCheckBoxSpatialIndex() {
    	if (jCheckBoxSpatialIndex == null) {
    		jCheckBoxSpatialIndex = new JCheckBox();
    		jCheckBoxSpatialIndex.setBounds(2, 33, 242, 23);
    		jCheckBoxSpatialIndex.setText(PluginServices.getText(this,"Usar_indice_espacial"));
    	}
    	return jCheckBoxSpatialIndex;
    }

    public int getLinkType()
    {
        return getJComboBox1().getSelectedIndex();
    }
    public String getSelectedLinkField()
    {
        return (String) getJComboBox().getSelectedItem();
    }

    public String getExtensionLink()
    {
        return getJTextField().getText();
    }

    public boolean isSpatialIndexSelected()
    {
        return getJCheckBoxSpatialIndex().isSelected();
    }

    private void showLayerInfo() {
		try {
			String info = ((FLyrDefault)layer).getInfoString();
			if (info == null) {
				Rectangle2D fullExtend = layer.getFullExtent();
				info = PluginServices.getText(this,"Extent") + "\n\t" +
				PluginServices.getText(this,"Superior") + ":\t" + fullExtend.getMaxY() + "\n\t" +
				PluginServices.getText(this,"Inferior") + ":\t" + fullExtend.getMinY() + "\n\t" +
				PluginServices.getText(this,"Izquierda") + ":\t" + fullExtend.getMinX() + "\n\t" +
				PluginServices.getText(this,"Derecha") + ":\t" + fullExtend.getMaxX() + "\n\n";

				if (layer instanceof FLyrVect) {
					ReadableVectorial rv=((FLyrVect)layer).getSource();
					if (rv instanceof VectorialEditableAdapter) {
						rv=((VectorialEditableAdapter) ((FLyrVect)layer).getSource()).getOriginalAdapter();
					}

					info = info + PluginServices.getText(this,"Origen_de_datos") + ": ";
					if (rv instanceof VectorialFileAdapter) {
						info = info + "\n" + rv.getDriver().getName() + "\n" +
						PluginServices.getText(this,"fichero") +": " + ((VectorialFileAdapter)rv).getFile();

					} else if (rv instanceof VectorialDBAdapter) {
						DBLayerDefinition dbdef = ((VectorialDBAdapter) rv).getLyrDef();
						info = info + "\n" + rv.getDriver().getName() + "\n";

						try {
							info = info +
							PluginServices.getText(this,"url") +": " + dbdef.getConnection().getURL() + "\n";
						} catch (Exception e) {
							//TODO: Que hacer aqui?
							e.printStackTrace();
						}

						info = info +
						PluginServices.getText(this,"Tabla") +": " + dbdef.getComposedTableName() + "\n";
					} else if (rv instanceof VectorialAdapter){
						info = info + "\n" + rv.getDriver().getName() + "\n";
					}



				} else {
					info = info + PluginServices.getText(this,"Origen_de_datos") + ": " + layer.getName();
				}

			}
			getJTextArea().setText(info);

		} catch (DriverException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

    }
}  //  @jve:decl-index=0:visual-constraint="10,10"

