package com.iver.cit.gvsig.project.documents.view.toc.gui;

import javax.swing.JDialog;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.cit.gvsig.fmap.layers.Annotation_Layer;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.project.documents.view.legend.gui.FThemeManagerWindow2;
import com.iver.cit.gvsig.project.documents.view.toc.AbstractTocContextMenuAction;
import com.iver.cit.gvsig.project.documents.view.toc.ITocItem;
import com.iver.cit.gvsig.project.documents.view.toc.actions.DelegatedTocContextMenuAction;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/**
 * Muestra el men de propiedades del tema.
 *
 * @author jmorell
 */

public class FLyrVectEditPropertiesTocMenuEntry2 extends
		DelegatedTocContextMenuAction {
	public FLyrVectEditPropertiesTocMenuEntry2(
			AbstractTocContextMenuAction delegated) {
		super(delegated);
	}

	public boolean isVisible(ITocItem item, FLayer[] selectedItems) {
		if (isTocItemBranch(item)) {
			FLayer lyr = getNodeLayer(item);
			if (lyr instanceof Annotation_Layer) {
				return true;
			}
		}
		return super.isVisible(item, selectedItems);
	}

	public void execute(ITocItem item, FLayer[] selectedItems) {
		FLayer[] actives = selectedItems;
		if (actives[0] instanceof Annotation_Layer)
			annotationExecute(item, selectedItems);
		else
			super.execute(item, selectedItems);
	}

	private void annotationExecute(ITocItem item, FLayer[] selectedItems) {
		FLayer[] actives = selectedItems;
		FThemeManagerWindow2 fThemeManagerWindow;
		if (actives.length == 1) {
			if (!actives[0].isAvailable())
				return;
			System.out
					.println("openPliegoThemeProperties(): Una sola capa. Abrimos el panel para la capa "
							+ actives[0]);
			fThemeManagerWindow = new FThemeManagerWindow2(actives[0],
					actives[0].getMapContext());
			try {
				fThemeManagerWindow.setMapContext(getMapContext());
			} catch (com.iver.cit.gvsig.fmap.DriverException e1) {
				NotificationManager.addError(e1);
			}
			if (PluginServices.getMainFrame() == null) {
				JDialog dlg = new JDialog();
				fThemeManagerWindow.setPreferredSize(fThemeManagerWindow
						.getSize());
				dlg.getContentPane().add(fThemeManagerWindow);
				dlg.setModal(false);
				dlg.pack();
				dlg.setVisible(true);
			} else {
				PluginServices.getMDIManager().addWindow(fThemeManagerWindow);
			}
		} else {
			for (int i = 0; i < actives.length; i++) {
				if (actives[0].isAvailable()) {
					System.out
							.println("openPliegoThemeProperties(): Muchas capas. Abrimos el panel para la capa "
									+ actives[i]);
					fThemeManagerWindow = new FThemeManagerWindow2(actives[i],
							getMapContext());
					if (PluginServices.getMainFrame() == null) {
						JDialog dlg = new JDialog();
						fThemeManagerWindow
								.setPreferredSize(fThemeManagerWindow.getSize());
						dlg.getContentPane().add(fThemeManagerWindow);
						dlg.setModal(false);
						dlg.pack();
						dlg.setVisible(true);
					} else {
						PluginServices.getMDIManager().addWindow(
								fThemeManagerWindow);
					}
				}
			}
		}
	}

}
