/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 */
package es.prodevelop.cit.gvsig.arcims.fmap.drivers;

import com.hardcode.driverManager.DriverLoadException;

import com.hardcode.gdbms.engine.data.DataSource;
import com.hardcode.gdbms.engine.data.DataSourceFactory;
import com.hardcode.gdbms.engine.data.driver.DriverException;
import com.hardcode.gdbms.engine.data.driver.ObjectDriver;
import com.hardcode.gdbms.engine.instruction.EvaluationException;
import com.hardcode.gdbms.engine.instruction.SemanticException;
import com.hardcode.gdbms.engine.values.*;
import com.hardcode.gdbms.parser.ParseException;

import com.iver.cit.gvsig.fmap.layers.FBitSet;

import org.apache.log4j.Logger;

import org.gvsig.remoteClient.arcims.utils.FieldInformation;

import java.awt.Dimension;

import java.io.IOException;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Types;

import java.util.ArrayList;
import java.util.HashMap;


public class ArcImsInMemoryAttsTableDriver {
    private static Logger logger = Logger.getLogger(FMapFeatureArcImsDriver.class.getName());
    private String tableName = "";

    // private String dataBName = "";
    private String idOriginalFieldName = "";
    private String idSqlFieldName = "";

    // private String rowIndexFieldName = "INMEMORYROWNUMBER";
    private int idFieldInd = -1;
    private FBitSet requested;
    private ArrayList sqlColumnNames = new ArrayList();
    private ArrayList originalColumnNames = new ArrayList();

    // private ArrayList originalColumnNames = new ArrayList();
    private ArrayList columnTypes = new ArrayList();

    // private int theRowCount = 0;
    private int theFieldCount = 0;
    private HashMap idToIndex;
    private Dimension lastRequest = new Dimension(-1, -1);

    // ------------------------------------------------
    private ArrayList data = new ArrayList();
    private ArrayList id = new ArrayList();

    // ------------------------------------------------
    // private ArcImsAttributesTableCachee attsCache;
    // private static Logger logger = Logger.getLogger(FMapFeatureArcImsDriver.class.getName());
    public ArcImsInMemoryAttsTableDriver(String tb_name, ArrayList colnames,
        ArrayList coltypes) {
        // super();
        tableName = tb_name;

        // dataBName = dbName;
        idFieldInd = getIdColumnInd(coltypes);

        idOriginalFieldName = (String) colnames.get(idFieldInd);
        idSqlFieldName = replaceUnwantedCharacters((String) colnames.get(
                    idFieldInd));

        requested = new FBitSet();

        for (int i = 0; i < colnames.size(); i++) {
            sqlColumnNames.add(replaceUnwantedCharacters(
                    (String) colnames.get(i)));
            originalColumnNames.add(colnames.get(i));
            columnTypes.add(coltypes.get(i));
            theFieldCount++;
        }

        idToIndex = new HashMap();
    }

    /**
     * user = "as", password = "", dbName = ?
     *
     * @see com.hardcode.gdbms.engine.data.driver.DBDriver#getConnection(java.lang.String,
     *      int, java.lang.String, java.lang.String, java.lang.String)
     */

    //    public Connection getConnection(String host, int port, String _dbName,
    //            String _user, String _password) throws SQLException {
    //        	
    ////            if (driverException != null) {
    ////                throw new RuntimeException(driverException);
    ////            }
    //            String connectionString = "jdbc:hsqldb:mem:" + dataBName;
    //            Connection c = DriverManager.getConnection(connectionString, "sa", "");
    //            return c;
    //        }

    //    public Connection getConnection() throws SQLException {
    //    	return getConnection("", 0, "", "", "");
    //        }

    /**
     * @see com.hardcode.driverManager.Driver#getName()
     */
    public String getName() {
        return "ArcIMS in-memory attributes data driver";
    }

    public void open(String sql) throws SQLException {
        //    	open(getConnection(), sql);
    }

    public void execute(String sql) throws SQLException {
        //    	execute(getConnection(), sql);
    }

    public String getDbName() {
        return "No database";
    }

    public int getIdFieldInd() {
        return idFieldInd;
    }

    public String getIdFieldName() {
        return idSqlFieldName;
    }

    // public void addRow(DataSourceFactory dsf, Value[] values) throws DriverException {
    public void addRow(Value[] values, boolean filled)
        throws DriverException {
        if (values.length < theFieldCount) {
            logger.error("Cannot add row with length < field count. ");

            return;
        }

        if (values[idFieldInd].toString().compareTo("") != 0) {
            // not null value
            int theid = ((IntValue) values[idFieldInd]).intValue();
            idToIndex.put(new Integer(theid), new Integer(data.size()));
        }

        requested.set(data.size(), filled);
        data.add(values);

        //		String fieldNames = "";
        //		for (int i=0; i < (values.length + 1); i++) {
        //			fieldNames = fieldNames + ((String) columnNames.get(i)) + ", "; 
        //		}
        //		fieldNames = fieldNames.substring(0, fieldNames.length() - 2);
        //		// + ArcImsSqlUtils.rowIndexFieldName;
        //		
        //		String fieldValues = "";
        //		for (int i=0; i<values.length; i++) {
        //			fieldValues = fieldValues + getValueInSqlFormat(values[i]) + ", "; 
        //		}
        //		fieldValues = fieldValues + getRowCount();
        //		
        //		String sqlStr = "insert into " + tableName + " (";
        //		sqlStr = sqlStr + fieldNames + ") values (";
        //		sqlStr = sqlStr + fieldValues + ")";
        //		/*
        //		* INSERT INTO Table1 (Column1, Column2, Column3?)
        //		* VALUES (Value1, Value2, Value3?)
        //		*/
        //		try {
        //			// dsf.executeSQL(sqlStr, DataSourceFactory.AUTOMATIC_OPENING);
        //			execute(sqlStr);
        //			theRowCount++;
        //		} catch (Exception e) {
        //			DriverException de = new DriverException(e.getMessage());
        //			throw de;
        //		}
    }

    // public void deleteRow(DataSourceFactory dsf, int i) throws DriverException {
    public void deleteRow(int i) throws DriverException {
        /*
         DELETE FROM Table1 WHERE Some_Column = Some_Value
         */
        logger.warn("deleteRow was invoqued, i = " + i);

        int theid = getRowId(i);
        idToIndex.remove(new Integer(theid));

        requested.set(i, false);
        data.set(i, null);

        //		String sqlStr = "delete from " + tableName + " where ";
        //		sqlStr = sqlStr + rowIndexFieldName + " = ";
        //		sqlStr = sqlStr + i;
        //		/*
        //		* INSERT INTO Table1 (Column1, Column2, Column3?)
        //		* VALUES (Value1, Value2, Value3?)
        //		*/
        //		try {
        //			// dsf.executeSQL(sqlStr, DataSourceFactory.AUTOMATIC_OPENING);
        //			execute(sqlStr);
        //			theRowCount--;
        //		} catch (Exception e) {
        //			DriverException de = new DriverException(e.getMessage());
        //			throw de;
        //		}
    }

    //	private String getValueInSqlFormat(Value v) {
    //		String tmp = v.getStringValue(internalValueWriter);
    ////		if (v instanceof StringValue) {
    ////			tmp = "'" + tmp + "'";
    ////		}
    //		return tmp;
    //	}
    private boolean isEmptyRow(int n) {
        return (data.get(n) == null);
    }

    public int getRowId(int row) throws DriverException {
        Integer rowid = (Integer) id.get(row);

        return rowid.intValue();

        //		Value[] therow = (Value []) data.get(row);
        //		return ((IntValue) therow[idFieldInd]).intValue();
        // return ((Integer) indexToId.get(new Integer(row))).intValue();
    }

    public int getRowIndex(int id) throws DriverException {
        // logger.debug("Searching for id: " + id);
        return ((Integer) idToIndex.get(new Integer(id))).intValue();
    }

    //	public int getRowId(DataSourceFactory dsf, int row) throws DriverException {
    //		/*
    //		 SELECT * FROM Customers WHERE LastName = 'Smith'
    //		 */
    //		String sqlStr = "select " + idFieldName + " from " + tableName + " where ";
    //		sqlStr = sqlStr + rowIndexFieldName + " = ";
    //		sqlStr = sqlStr + row + ";";
    //		/*
    //		* INSERT INTO Table1 (Column1, Column2, Column3?)
    //		* VALUES (Value1, Value2, Value3?)
    //		*/
    //		DataSource ds = null;
    //		try {
    //			
    //			ds = dsf.executeSQL(sqlStr, DataSourceFactory.AUTOMATIC_OPENING);
    //			// int respind = ds.getFieldIndexByName(idFieldName);
    //			IntValue resp = (IntValue) ds.getFieldValue(0, 0);
    //			return resp.intValue();
    //		} catch (Exception e) {
    //			DriverException de = new DriverException(e.getMessage());
    //			throw de;
    //		}
    //	}
    //	
    //	public int getRowIndex(DataSourceFactory dsf, int id) throws DriverException {
    //		String sqlStr = "select " + rowIndexFieldName + " from " + tableName + " where ";
    //		sqlStr = sqlStr + idFieldName + " = ";
    //		sqlStr = sqlStr + id + ";";
    //		/*
    //		* INSERT INTO Table1 (Column1, Column2, Column3?)
    //		* VALUES (Value1, Value2, Value3?)
    //		*/
    //		DataSource ds = null;
    //		try {
    //			ds = dsf.executeSQL(sqlStr, DataSourceFactory.AUTOMATIC_OPENING);
    //
    //			System.err.println("getRowIndex of id = " + id);
    //			System.err.println(ds.getAsString());
    //			System.err.println("------------------------------");
    //			// int respind = ds.getFieldIndexByName(idFieldName);
    //			IntValue resp = (IntValue) ds.getFieldValue(0, 0);
    //			return resp.intValue();
    //		} catch (Exception e) {
    //			DriverException de = new DriverException(e.getMessage());
    //			throw de;
    //		}
    //	}
    public boolean isNonRequestedRow(int rowind) {
        // TODO Auto-generated method stub
        return (!requested.get(rowind));
    }

    // public void updateRow(DataSourceFactory dsf, Value[] new_row, String[] fld_q) throws DriverException {
    // TODO so far, this method is called with
    // a full field query (except rowindex)
    public void updateRow(Value[] upd_row, String[] fld_q, int rowind)
        throws DriverException {
        if (!isEmptyRow(rowind)) {
            int newid = 0;
            int oldid = getRowId(rowind);
            boolean done = false;

            for (int i = 0; i < fld_q.length; i++) {
                if (fld_q[i].compareTo(idSqlFieldName) == 0) {
                    newid = ((IntValue) upd_row[i]).intValue();
                    done = true;
                }
            }

            if (done) {
                idToIndex.remove(new Integer(oldid));
                idToIndex.put(new Integer(newid), new Integer(rowind));
            }
        }

        Value[] newrow = new Value[theFieldCount];

        if (data.get(rowind) == null) {
            data.set(rowind, newrow);
        }
        else {
            newrow = (Value[]) data.get(rowind);
        }

        if (fld_q[0].compareTo("#ALL#") == 0) {
            for (int i = 0; i < upd_row.length; i++) {
                newrow[i] = upd_row[i];
            }
        }
        else {
            int fldind = 0;

            for (int i = 0; i < fld_q.length; i++) {
                String sqlname = replaceUnwantedCharacters(fld_q[i]);
                fldind = getFieldIndexByName(sqlname);
                newrow[fldind] = upd_row[i];
            }
        }

        //		data.set()
        //		String[] fld_query = null;
        //		if (fld_q[0].compareTo("#ALL#") == 0) {
        //			
        //			int count = getFieldCount() - 1;
        //			fld_query = new String[count];
        //			for (int i=0; i<count; i++) {
        //				fld_query[i] = getFieldName(i);
        //			}
        //			
        //			
        //		} else {
        //			fld_query = new String[fld_q.length];
        //			for (int i=0; i<fld_q.length; i++) {
        //				fld_query[i] = ArcImsSqlUtils.getSqlCompliantFieldName(fld_q[i]);
        //			}
        //		}
        //		
        //		IntValue id = null;
        //		for (int i=0; i<fld_query.length; i++) {
        //			if (fld_query[i].compareTo(idFieldName) == 0) {
        //				id = (IntValue) new_row[i];
        //			}
        //		}
        //		if (id == null) {
        //			DriverException de = new DriverException("id_not_found");
        //			throw de;
        //		}
        //		int intid = id.intValue();
        //		
        //		String sqlStr = "update " + tableName + " set ";
        //		String nthFieldName, nthFieldValue;
        //		for (int i=0; i<fld_query.length; i++) {
        //			nthFieldName = fld_query[i];
        //			nthFieldValue = this.getValueInSqlFormat(new_row[i]);
        //			sqlStr = sqlStr + nthFieldName + " = ";
        //			sqlStr = sqlStr + nthFieldValue + ", ";
        //		}
        //		sqlStr = sqlStr.substring(0, sqlStr.length() - 2);
        //		sqlStr = sqlStr + " where " + idFieldName + " = " + intid + ";";
        //		try {
        //			// dsf.executeSQL(sqlStr, DataSourceFactory.AUTOMATIC_OPENING);
        //			execute(sqlStr);
        //		} catch (Exception e) {
        //			DriverException de = new DriverException(e.getMessage());
        //			throw de;
        //		}
    }

    public int getFieldIndexByName(String arg0) throws DriverException {
        //		String arg00 = ArcImsSqlUtils.getSqlCompliantFieldName(arg0);
        if (arg0 == null) {
            logger.error("Somebody asked for the index of a null field ");

            return -1;
        }

        for (int i = 0; i < sqlColumnNames.size(); i++) {
            if (((String) sqlColumnNames.get(i)).compareTo(arg0) == 0) {
                return i;
            }
        }

        logger.error("Field not found ");

        return -1;
    }

    public Value[] getRow(DataSourceFactory dsf, int n)
        throws DriverException {
        return (Value[]) data.get(n);

        //		String sqlStr = "select * from " + tableName + " where ";
        //		sqlStr = sqlStr + rowIndexFieldName + " = " + n + ";";
        //
        //		try {
        //			DataSource ds =
        //				dsf.executeSQL(sqlStr, DataSourceFactory.AUTOMATIC_OPENING);
        //			// int respind = ds.getFieldIndexByName(idFieldName);
        //			int count = ds.getFieldCount();
        //			Value[] resp = new Value[count];
        //			for (int i=0; i<count; i++) {
        //				resp[i] = ds.getFieldValue(0, i);
        //			}
        //			return resp;
        //		} catch (Exception e) {
        //			DriverException de = new DriverException(e.getMessage());
        //			throw de;
        //		}
    }

    //	public String getRowIndexFieldName() {
    //		return rowIndexFieldName;
    //	}
    public void setRequested(int n, boolean req) {
        requested.set(n, req);
    }

    public void addTheseAsRequested(FBitSet fbs) {
        requested.or(fbs);
    }

    public long getRowCount() {
        return (long) data.size();
    }

    public int getFieldCount() {
        return theFieldCount;
    }

    public String getFieldName(int i) {
        return (String) sqlColumnNames.get(i);
    }

    public int getFieldType(int i) {
        return ((Integer) columnTypes.get(i)).intValue();
    }

    //	public void addInIndexToIdHashMap(int rwcount, int i) {
    //		indexToId.put(new Integer(rwcount), new Integer (i));
    //	}
    public void addInIdToIndexHashMap(int i, int rwcount) {
        idToIndex.put(new Integer(i), new Integer(rwcount));
    }

    //	public String getColumnName(int i) {
    //		return (String) columnNames.get(i);
    //	}

    //	public void increaseRowCount(boolean req) {
    //		requested.set(data.size(), req);
    //		theRowCount++;
    //	}
    public void addAsRequested(FBitSet fbs) {
        requested.or(fbs);
    }

    public FBitSet getThisAndNonRequestedUpTo(int _thisone, int total) {
        int thisone = _thisone;
        int rowcount = (int) getRowCount();

        if (_thisone >= rowcount) {
            thisone = _thisone % rowcount;
        }

        FBitSet fbs = new FBitSet();
        fbs.set(thisone);

        if (total < 2) {
            return fbs;
        }

        int othersMustBeSet = total - 1;
        int checkind;

        for (int j = 1; j < rowcount; j++) {
            // checkind = (i + j) % noOfRows;
            checkind = (thisone + j) % rowcount;

            if (isNonRequestedRow(checkind)) {
                fbs.set(checkind);
                othersMustBeSet--;
            }

            if (othersMustBeSet == 0) {
                break;
            }
        }

        return fbs;
    }

    public void addEmptyRowWithId(Value idval, String idcolname) {
        data.add(null);
        id.add(new Integer(((IntValue) idval).intValue()));
    }

    public Value getFieldValue(long row, int colind) {
        // printLastAndUpdate(row, colind);
        if ((row >= getRowCount()) || (row < 0)) {
            logger.error("Row index out of limits ");

            return null;
        }

        Value[] therow = (Value[]) data.get((int) row);

        if (therow == null) {
            logger.error("Tried to get non available value (?) ");

            return null;
        }

        if ((colind >= therow.length) || (colind < 0)) {
            logger.error("Field index out of limits ");

            return null;
        }

        if (therow[colind] == null) {
            logger.warn("In order to avoid returning element [ " + row + ", " +
                colind +
                " ] (which is null), returned ValueFactory.createNullValue()");

            return ValueFactory.createNullValue();
        }
        else {
            return therow[colind];
        }
    }

    private void printLastAndUpdate(long row, int colind) {
        logger.debug("Last request: [ " + lastRequest.height + " , " +
            lastRequest.width + " ]");
        lastRequest.height = (int) row;
        lastRequest.width = colind;
        logger.debug("Current request: [ " + lastRequest.height + " , " +
            lastRequest.width + " ]");
    }

    //	public Value getCachedValue(int row, int attind) {
    //		return attsCache.getAttribute(row, attind);
    //	}
    //	
    //	public void setCachedValue(int row, int attind, Value v) {
    //		attsCache.addToCache(row, attind, v);
    //	}
    public int getIdColumnInd(ArrayList col_Types) {
        int coltype;
        int idindex = -1;

        for (int i = 0; i < col_Types.size(); i++) {
            coltype = ((Integer) col_Types.get(i)).intValue();

            if (coltype == FieldInformation.ID) {
                idindex = i;

                break;
            }
        }

        if (idindex == -1) {
            logger.error("ID not found ");
        }

        return idindex;
    }

    public String getTableName() {
        return tableName;
    }

    public static String replaceUnwantedCharacters(String str) {
        String resp = str;
        resp = resp.replace('.', '_');
        resp = resp.replace('#', 'z');

        return resp;
    }

    public String getOriginalFieldName(int idcolindex) {
        return (String) originalColumnNames.get(idcolindex);
    }

    public String getSqlFieldName(int idcolindex) {
        return (String) sqlColumnNames.get(idcolindex);
    }
}
