/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package com.iver.cit.gvsig.fmap.tools;

import java.awt.Cursor;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.geom.Rectangle2D;

import javax.swing.ImageIcon;

import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.tools.Events.RectangleEvent;
import com.iver.cit.gvsig.fmap.tools.Listeners.RectangleListener;


/**
 * Implementacin de la interfaz RectangleListener como herramienta para
 * realizar un zoom ms en la imagen a georeferenciar.
 *
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class ZoomGeorefListenerImpl implements RectangleListener {
	private static final Image izoomin = new ImageIcon(MapControl.class.getResource(
				"images/ZoomInCursor.gif")).getImage();
	
	public static Cursor cur = Toolkit.getDefaultToolkit().createCustomCursor(izoomin, new Point(16, 16), "");
	
	private MapControl mapCtrl;

	/**
	 * Crea un nuevo RectangleListenerImpl.
	 *
	 * @param mapCtrl MapControl.
	 */
	public ZoomGeorefListenerImpl(MapControl mapCtrl) {
		this.mapCtrl = mapCtrl;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.tools.Listeners.RectangleListener#rectangle(com.iver.cit.gvsig.fmap.tools.Events.RectangleEvent)
	 */
	public void rectangle(RectangleEvent event) {
		Rectangle2D rect = event.getWorldCoordRect();
		Rectangle2D pixelRect = event.getPixelCoordRect();
		Rectangle2D.Double r = new Rectangle2D.Double();	
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.tools.Listeners.ToolListener#getCursor()
	 */
	public Cursor getCursor() {
		return cur;
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.tools.Listeners.ToolListener#cancelDrawing()
	 */
	public boolean cancelDrawing() {
	    System.out.println("cancelDrawing del ZoomOutListenerImpl");
		return true;
	}
}
