/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package org.gvsig.georeferencing;

import org.gvsig.georeferencing.toc.GeoRasterTocMenuEntry;
import org.gvsig.georeferencing.wizards.GeoRasterWizard;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.cit.gvsig.AddLayer;
import com.iver.cit.gvsig.project.documents.view.gui.View;
import com.iver.cit.gvsig.project.documents.view.toc.gui.FPopupMenu;


/**
 * Extensin que carga el modulo de georeferenciacin
 *
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class GeoreferencingModule extends Extension{
	
	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
		AddLayer.addWizard(GeoRasterWizard.class);
		FPopupMenu.addEntry(new GeoRasterTocMenuEntry());
	}
	
	/**
	 * El control est activo siempre que haya una vista abierta
	 */
	public boolean isEnabled() {
		com.iver.andami.ui.mdiManager.IWindow f = null;
		try{
			f = PluginServices.getMDIManager().getActiveWindow();
		}catch(ClassCastException exc){
			return false;
		}

		if (f == null) {
			return false;
		}

		return (f.getClass() == View.class);
	}

	/**
	 * El control es visible siempre que haya una vista abierta
	 */
	public boolean isVisible() {
		com.iver.andami.ui.mdiManager.IWindow f = null;
		try{
			f = PluginServices.getMDIManager().getActiveWindow();
		}catch(ClassCastException exc){
			return false;
		}
		
		if (f == null) {
			return false;
		}

		return (f.getClass() == View.class);
	}

	/**
	 * Cuando ejecutamos el control de georeferenciacin se activan las heramientas
	 * de georeferenciacin y se carga el wizard.
	 */
	public void execute(String s) {
		
	}
}