/**
 *
 */
package org.gvsig.rasterTools.exportToGeoRaster;

import org.gvsig.rasterTools.exportToGeoRaster.ui.ExportToGeoRasterDialog;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.fmap.layers.LayersIterator;
import com.iver.cit.gvsig.project.documents.view.gui.View;

/**
 * @author jmvivo
 *
 */
public class ExportToGeoRasterExtension extends Extension {

	/* (non-Javadoc)
	 * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
	 */
	public void execute(String actionCommand) {

		View f = (View)PluginServices.getMDIManager().getActiveWindow();

		LayersIterator iter = getActiveRasterLayers(f.getMapControl().getMapContext().getLayers());

		if (!iter.hasNext()){
			return;
		}

		FLyrRaster layer = (FLyrRaster)iter.nextLayer();
		int	width = 550;
		int height = 600;

		ExportToGeoRasterDialog dialog = new ExportToGeoRasterDialog(layer,width,height,f.getMapControl(),f.getModel().getName());

		PluginServices.getMDIManager().addWindow(dialog);


	}

	/* (non-Javadoc)
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see com.iver.andami.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
		View f = (View)PluginServices.getMDIManager().getActiveWindow();

		LayersIterator iter = getActiveRasterLayers(f.getMapControl().getMapContext().getLayers());

		if (!iter.hasNext()){
			return false;
		}

		FLayer layer = iter.nextLayer();

		// enabled when only one layer was selected
		if (iter.hasNext()){
			return false;
		}
		return true;

	}

	/* (non-Javadoc)
	 * @see com.iver.andami.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		IWindow f = PluginServices.getMDIManager().getActiveWindow();
		if (f == null)
			return false;

		return (f  instanceof View);
	}

	public LayersIterator getActiveRasterLayers(FLayers layers) {
		return new LayersIterator(layers){

			/* (non-Javadoc)
			 * @see com.iver.cit.gvsig.fmap.layers.LayersIterator#evaluate(com.iver.cit.gvsig.fmap.layers.FLayer)
			 */
			public boolean evaluate(FLayer layer) {
				// TODO Auto-generated method stub
				return layer.isActive() && layer instanceof FLyrRaster;
			}

		};
	}

}
