package org.gvsig.rasterTools.scaleManager;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.cresques.filter.IStackManager;
import org.cresques.filter.RasterFilterStackManager;
import org.cresques.ui.raster.IResize;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.gui.panels.IRasterPropertiesRegistrable;
import com.iver.cit.gvsig.gui.panels.PropertiesRasterDialog;
import com.iver.cit.gvsig.project.documents.view.toc.gui.FLyrRasterAdjustPropertiesTocMenuEntry;

public class ScaleManagerPanel extends JPanel implements IResize,
		IRasterPropertiesRegistrable {

	/**
	 *
	 */
	private static final long serialVersionUID = 177311346136230777L;

	private String panelName = null;

	private int sizeX = 445;

	private int sizeY = 174;

	private int wComp = 445, hComp = 239;

	private JPanel jPanel1 = null;

	private JPanel jPanel4 = null;

	private JPanel jPanel5 = null;

	private ButtonGroup buttonGroup = null;

	private JLabel jLabel4 = null;

	private JLabel jLabel3 = null;

	private JLabel jLabel2 = null;

	private JLabel jLabel1 = null;

	private JRadioButton jRadioButton = null;

	private JRadioButton jRadioButton1 = null;

	private JTextField jTextField1 = null;

	private JTextField jTextField2 = null;

	public ScaleManagerPanel(FLyrRasterAdjustPropertiesTocMenuEntry menu) {
		super();
		initialize();
		this.setTranslation();
		menu.register(this);
	}

	/* (non-Javadoc)
	 * @see org.cresques.ui.raster.IResize#setComponentSize(int, int)
	 */
	public void setComponentSize(int w, int h) {
		wComp = w;
		hComp = h;
		this.setSize(wComp, hComp);
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.gui.panels.IRasterPropertiesRegistrable#actionPerformed(org.cresques.filter.RasterFilterStackManager, com.iver.cit.gvsig.gui.panels.PropertiesRasterDialog, com.iver.cit.gvsig.fmap.layers.FLyrRaster)
	 */
	public void actionPerformed(RasterFilterStackManager stackManager,
			PropertiesRasterDialog propsDialog, FLyrRaster fLayer) {
		if (fLayer == null){
			return;
		}
		double minScale = -1;
		double maxScale = -1;
		String minText = this.getJTextField1().getText();
		String maxText = this.getJTextField2().getText();

		if (!minText.equals("")) {
			try{
				minScale = Double.parseDouble(minText);
			} catch (NumberFormatException e) {
				// TODO: handle exception
				minScale = fLayer.getMinScale();
			}
		}
		if (!maxText.equals("")) {
			try{
				maxScale = Double.parseDouble(maxText);
			} catch (NumberFormatException e) {
				// TODO: handle exception
				maxScale = fLayer.getMaxScale();
			}
		}

		fLayer.setMaxScale(maxScale);
		fLayer.setMinScale(minScale);

	}

	public void addTabPanel(FLyrRasterAdjustPropertiesTocMenuEntry menu) {
		menu.getPropertiesDialog().addTab(this.getName(), this);
	}

	public IStackManager getStackManager() {
		return null;
	}

	public void setStackManager(RasterFilterStackManager stackManager) {
	}

	public String getName() {
		if (this.panelName == null) {
			this.panelName = PluginServices.getText(this, "escala");
		}
		return panelName;
	}

	void initialize() {
		this.setPreferredSize(new Dimension(sizeX, sizeY));
		this.setLayout(new GridLayout(1, 1));
		this.setLocation(0, 0);
		this.setSize(wComp, hComp);
		this.add(getJPanel1(), null);

	}

	/**
	 * Traducciones del panel
	 */
	public void setTranslation() {
		// this.getCbActiveSharpening().setText(PluginServices.getText(this,"onSharpening"));
		// this.getPSharpNorth().setBorder(javax.swing.BorderFactory.createTitledBorder(null,
		// PluginServices.getText(this,"selectBandaRefinado"),
		// javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
		// javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
	}

	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jPanel1.setLayout(null);
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(
					null, PluginServices.getText(this, "rango_de_escalas"),
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION, null,
					null));
			jPanel1.setBounds(5, 61, 432, 137);
			jPanel1.add(getJPanel4(), null);
			jPanel1.add(getJPanel5(), null);
		}
		return jPanel1;
	}

	private JPanel getJPanel4() {
		if (jPanel4 == null) {
			jPanel4 = new JPanel();
			jPanel4.setLayout(null);
			jPanel4.setBounds(6, 21, 398, 46);
			jPanel4.add(getJRadioButton(), null);
			jPanel4.add(getJRadioButton1(), null);
			buttonGroup = new ButtonGroup();
			buttonGroup.add(getJRadioButton());
			buttonGroup.add(getJRadioButton1());
		}
		return jPanel4;
	}

	private JPanel getJPanel5() {
		if (jPanel5 == null) {
			jLabel4 = new JLabel();
			jLabel3 = new JLabel();
			jLabel2 = new JLabel();
			jLabel1 = new JLabel();
			jPanel5 = new JPanel();
			jPanel5.setLayout(null);
			jLabel1
					.setText(PluginServices
							.getText(this, "este_por_debajo_de_"));
			jLabel1.setBounds(6, 6, 138, 20);
			jLabel1.setEnabled(false);
			jLabel2.setText("(" + PluginServices.getText(this, "escala_minima")
					+ ")");
			jLabel2.setBounds(302, 6, 111, 20);
			jLabel2.setEnabled(false);
			jPanel5.setBounds(15, 69, 414, 53);
			jLabel3.setBounds(6, 31, 138, 20);
			jLabel3.setText(PluginServices.getText(this, "este_por_encima_de"));
			jLabel3.setEnabled(false);
			jLabel4.setBounds(302, 31, 111, 20);
			jLabel4.setText("(" + PluginServices.getText(this, "escala_maxima")
					+ ")");
			jLabel4.setEnabled(false);
			jPanel5.add(jLabel1, null);
			jPanel5.add(getJTextField1(), null);
			jPanel5.add(jLabel2, null);
			jPanel5.add(jLabel3, null);
			jPanel5.add(getJTextField2(), null);
			jPanel5.add(jLabel4, null);
		}
		return jPanel5;
	}

	public JRadioButton getJRadioButton() {
		if (jRadioButton == null) {
			jRadioButton = new JRadioButton();
			jRadioButton.setText(PluginServices
					.getText(this, "Mostrar_siempre"));
			jRadioButton.setBounds(0, 0, 301, 23);
			jRadioButton.setSelected(true);
			jRadioButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					// jPanel5.setEnabled(false);
					jLabel1.setEnabled(false);
					jTextField1.setEnabled(false);
					jLabel2.setEnabled(false);
					jLabel3.setEnabled(false);
					jTextField2.setEnabled(false);
					jLabel4.setEnabled(false);
				}
			});
		}
		return jRadioButton;
	}

	public JRadioButton getJRadioButton1() {
		if (jRadioButton1 == null) {
			jRadioButton1 = new JRadioButton();
			jRadioButton1.setText(PluginServices.getText(this,
					"No_mostrar_la_capa_cuando_la_escala"));
			jRadioButton1.setBounds(0, 23, 301, 23);
			jRadioButton1
					.addActionListener(new java.awt.event.ActionListener() {
						public void actionPerformed(java.awt.event.ActionEvent e) {
							// jPanel5.setEnabled(true);
							jLabel1.setEnabled(true);
							jTextField1.setEnabled(true);
							jLabel2.setEnabled(true);
							jLabel3.setEnabled(true);
							jTextField2.setEnabled(true);
							jLabel4.setEnabled(true);
						}
					});
		}
		return jRadioButton1;
	}

	public JTextField getJTextField1() {
		if (jTextField1 == null) {
			jTextField1 = new JTextField();
			jTextField1.setBounds(147, 6, 152, 20);
			jTextField1.setEnabled(false);
		}
		return jTextField1;
	}

	public JTextField getJTextField2() {
		if (jTextField2 == null) {
			jTextField2 = new JTextField();
			jTextField2.setBounds(147, 31, 152, 20);
			jTextField2.setEnabled(false);
		}
		return jTextField2;
	}

}
