package com.iver.cit.gvsig.gui.panels;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.Vector;

import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.gvsig.remoteClient.gml.schemas.XMLElement;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.WFSLayerNode;
import com.iver.cit.gvsig.gui.panels.attributesTree.AttributesTreeTable;
import com.iver.cit.gvsig.gui.panels.attributesTree.AttributesTreeTableModel;
import com.iver.cit.gvsig.gui.panels.attributesTree.TreeTableModelWithCheckBoxes;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSSelectAttributesPanel.java,v 1.7.2.5 2007/01/08 09:52:11 ppiqueras Exp $
 * $Log: WFSSelectAttributesPanel.java,v $
 * Revision 1.7.2.5  2007/01/08 09:52:11  ppiqueras
 * Corridos bugs + nueva funcionalidad.
 *
 * Revision 1.5  2006/12/26 09:19:52  ppiqueras
 * Cambiado "atttibutes" en todas las aparaciones en atributos, métodos, clases, paquetes o comentarios por "fields". (Sólo a aquellas que afectan a clases dentro del proyecto extWFS2).
 *
 * Revision 1.17  2006/12/15 13:58:25  ppiqueras
 * Eliminado un import que sobraba, y reorganizado código
 *
 * Revision 1.16  2006/12/04 08:59:47  ppiqueras
 * Algunos bugs corregidos. A cambio hay 2 bugs relacionados que todavía no han sido corregidos (ver PHPCollab) (los tiene asignados Jorge).
 *
 * Revision 1.15  2006/11/01 17:29:08  jorpiell
 * Se ha elimiado el nodo virtual de la raiz. Adems ya se cargan los valores de un campo complejo en la pestaa del filtro
 *
 * Revision 1.14  2006/10/31 09:39:18  jorpiell
 * Cambiado el tamao del panel
 *
 * Revision 1.13  2006/10/27 11:33:19  jorpiell
 * Aadida la treetable con los check box para seleccionar los atributos
 *
 * Revision 1.12  2006/10/24 07:58:14  jorpiell
 * Eliminado el parametro booleano que haca que apareciesen mas de una columna en el tree table
 *
 * Revision 1.11  2006/10/24 07:27:56  jorpiell
 * Algunos cambios en el modelo que usa la tabla
 *
 * Revision 1.10  2006/10/10 12:55:06  jorpiell
 * Se ha aadido el soporte de features complejas
 *
 * Revision 1.9  2006/10/02 09:09:45  jorpiell
 * Cambios del 10 copiados al head
 *
 * Revision 1.7.2.1  2006/09/19 12:28:11  jorpiell
 * Ya no se depende de geotools
 *
 * Revision 1.8  2006/09/18 12:07:31  jorpiell
 * Se ha sustituido geotools por el driver de remoteservices
 *
 * Revision 1.7  2006/09/05 13:01:31  jorpiell
 * Reducido el tamao de los botones
 *
 * Revision 1.6  2006/07/24 07:30:33  jorpiell
 * Se han eliminado las partes duplicadas y se est usando el parser de GML de FMAP.
 *
 * Revision 1.5  2006/07/21 11:50:31  jaume
 * improved appearance
 *
 * Revision 1.4  2006/06/21 12:35:45  jorpiell
 * Se ha aadido la ventana de propiedades. Esto implica aadir listeners por todos los paneles. Adems no se muestra la geomatra en la lista de atributos y se muestran nicamnete los que se van a descargar
 *
 * Revision 1.3  2006/06/15 07:50:58  jorpiell
 * Aadida la funcionalidad de reproyectar y hechos algunos cambios en la interfaz
 *
 * Revision 1.2  2006/05/26 06:29:42  jorpiell
 * Se ha cambiado el tamao de los botones. Adems, al seleccionar todos los atributos se seleccionan en orden.
 *
 * Revision 1.1  2006/05/25 10:30:13  jorpiell
 * Esta clase se ha renombrado. WFSFields era algo confusa
 *
 * Revision 1.3  2006/05/23 08:09:39  jorpiell
 * Se ha cambiado la forma en la que se leian los valores seleccionados en los paneles y se ha cambiado el comportamiento de los botones
 *
 * Revision 1.2  2006/05/19 12:57:08  jorpiell
 * Modificados algunos paneles
 *
 * Revision 1.1  2006/04/20 16:38:24  jorpiell
 * Ahora mismo ya se puede hacer un getCapabilities y un getDescribeType de la capa seleccionada para ver los atributos a dibujar. Queda implementar el panel de opciones y hacer el getFeature().
 *
 *
 */
/**
 * This panel shows the feature fields list
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 * @author Pablo Piqueras Bartolom (p_queras@hotmail.com)
 */
public class WFSSelectAttributesPanel extends JPanel {
	private static final long serialVersionUID = 3073243334672620143L;
	private JScrollPane fieldsScroll = null;
	private AttributesTreeTable fieldsTreeTable = null;
	private AttributesTreeTableModel model = null;
	private WFSParamsPanel parent = null;
	private JPanel treeTablePanel = null;
	private boolean fieldsSelectedOfSameLayerHasChanged;

	public WFSSelectAttributesPanel(WFSParamsPanel parent){
		super();
		this.parent = parent;
		initialize();
	}

	public void initialize(){
		this.setLayout(null);
		this.setBounds(10, 5, 481, 427);		
		this.add(getTreeTablePanel(), null);
		fieldsSelectedOfSameLayerHasChanged = false;
	}

	/**
	 * This method initializes jScrollPane3
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getFieldsScroll() {
		if (fieldsScroll == null) {
			fieldsScroll = new JScrollPane();
			fieldsScroll.setLocation(new java.awt.Point(6,20));
			fieldsScroll.setSize(new java.awt.Dimension(470,349));
			fieldsScroll.setViewportView(getAttributesTreeTable());
		}
		return fieldsScroll;
	}

	/**
	 * This method initializes lstTemps
	 *
	 * @return javax.swing.JList
	 */
	public AttributesTreeTable getAttributesTreeTable() {
		if (fieldsTreeTable == null) {
			model = new TreeTableModelWithCheckBoxes();
			fieldsTreeTable = new AttributesTreeTable(model,this);
			fieldsTreeTable.setLocation(new java.awt.Point(7,4));
			fieldsTreeTable.setSize(new java.awt.Dimension(482,302));
			
			// If user has changed the fields selection in the same layer
			fieldsTreeTable.addPropertyChangeListener(new PropertyChangeListener() {
				/*
				 *  (non-Javadoc)
				 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
				 */
				public void propertyChange(PropertyChangeEvent evt) {
					// If the selection of the fields of the layer has changed
					if (evt.getPropertyName().compareTo("tableCellEditor") == 0)
					{
						fieldsSelectedOfSameLayerHasChanged = true;						
					}					
					else if (evt.getPropertyName().compareTo("selectionModel") == 0) { // If the layer has changed
						fieldsSelectedOfSameLayerHasChanged = false;
					}
				}
			});
		}
		return fieldsTreeTable;
	}

	public void refresh(WFSLayerNode feature){
		setFields(feature);			
	}

	/**
	 *
	 * @param feature
	 */
	private void setFields(WFSLayerNode feature){
		Vector fields = feature.getFields();
		model = new TreeTableModelWithCheckBoxes(fields.get(0));
		fieldsTreeTable.setModel(model);
	}
	
	public void setSelectedFields(WFSLayerNode feature){
		Vector selectedFields = feature.getSelectedFields();
		fieldsTreeTable.setSelectedFields(selectedFields);
	}		

	/**
	 *
	 * @return the selected fields.
	 */
	public XMLElement[] getSelectedFields(){
		return fieldsTreeTable.getSelectedElements();
	}

	/**
	 * This method initializes treeTablePanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getTreeTablePanel() {
		if (treeTablePanel == null) {
			treeTablePanel = new JPanel();
			treeTablePanel.setLayout(null);
			treeTablePanel.setLocation(new java.awt.Point(7,4));
			treeTablePanel.setSize(new java.awt.Dimension(482,375));
			treeTablePanel.add(getFieldsScroll(), null);
			treeTablePanel.setBorder(javax.swing.BorderFactory.createTitledBorder(
					null, PluginServices.getText(this, "select_fields"),
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
		}
		return treeTablePanel;
	}
	
	/**
	 * Returns true if user has changed the selection of some field of the same layer; else returns false
	 * 
	 * @return A boolean value
	 */
	public boolean getFieldsSelectedOfSameLayerHasChanged() {
		return this.fieldsSelectedOfSameLayerHasChanged;
	}
	
	/**
	 * @param updated The updated to set.
	 */
	public void setUpdated(boolean updated) {
		parent.isApplicable(updated);
	}

	/**
	 * Resets the value of the field 'fieldsSelectedOfSameLayerHasChanged'
	 * 
	 * @return A boolean value
	 */
	public void resetFieldsSelectedOfSameLayerHasChanged() {
		this.fieldsSelectedOfSameLayerHasChanged = false;
	}
}  //  @jve:decl-index=0:visual-constraint="10,22"
