/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.io;


/**
 * Este interfaz debe ser implementado por las clases que vayan a
 * servir datos a los drivers de escritura.
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public interface IDataWriter {
	public int[] readARGBData(int sizeX, int sizeY, int nBand);
	
    public byte[][] readByteData(int sizeX, int sizeY);
    public short[][] readShortData(int sizeX, int sizeY);
    public int[][] readIntData(int sizeX, int sizeY);
    public float[][] readFloatData(int sizeX, int sizeY);
    public double[][] readDoubleData(int sizeX, int sizeY);
}
