/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.cresques.io;

import org.cresques.cts.ICoordTrans;
import org.cresques.cts.IProjection;

import org.cresques.px.IObjList;
import org.cresques.px.gml.*;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;


/**
 * Clase de soporte para ficheros .shp de ArcView
 *
 * @author "Luis W. Sevilla" <sevilla_lui@gva.es>* @author administrador
 * TODO extension .shp sin implementar
 */
public class ShpFile extends GeoFile {
    private String name;
    int l = 0;
    FeatureCollection collection = null;

    /**
     * Constructor de la clase Shp
     *
     */
    public ShpFile(IProjection proj, String name) {
        super(proj, name);
    }

    /**
     * Carga un .gml
     * @param name nombre del fichero
     */
    public GeoFile load() {
        System.out.println("Cargando " + name + " ...");

        try {
            if (FileFolder.isUrl(name)) {
                ZipFileFolder zFolder = new ZipFileFolder(name);

                return load(zFolder.getInputStream(name));
            } else {
                return load(new FileInputStream(name));
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException ie) {
            System.err.println("ERROR." + l + "lineas leidas");
            ie.printStackTrace();
        }

        return this;
    }

    public int openLayer() {
        String m_Path = null;

        try {
            FileInputStream fin = new FileInputStream(m_Path);

            // Open the file and then get a channel from the stream
            FileChannel fc = fin.getChannel();
            long sz = fc.size();

            // Get the file's size and then map it into memory
            MappedByteBuffer bb = fc.map(FileChannel.MapMode.READ_ONLY, 0, sz);
        } catch (Exception e) {
            System.err.notify();
        }

        return 0;
    }

    public GeoFile load(InputStream is) {
        // create a new header.
        ShpFileHeader myHeader = new ShpFileHeader();

        // read the header
        //myHeader.readHeader(fr);
        return this;
    }

    /**
     * Obtiene la lista de features.
     */
    public IObjList getObjects() {
        return collection;
    }

    public void reProject(ICoordTrans rp) {
        // TODO metodo reProject pendiente de implementar
    }

    /* (non-Javadoc)
     * @see org.cresques.io.GeoFile#close()
     */
    public void close() {
        // TODO Auto-generated method stub
    }
}
