/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */

package org.cresques.ui.BrightnessContrast;

import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JLabel;

/**
 * Clase que contiene slider, campo de texto, etiqueta para el nombre y un 
 * checkBox para habilitar o deshabilitar el slider y el campo de texto.
 * @author Miguel ngel Querol Carratal  <querol_mig@gva.es>
 *
 */
public class CheckSliderText extends SliderTextPanel implements ActionListener{
	
	public JLabel lName = null;
	public JCheckBox cSliderText = null;
	
	/**
	 * Constructor
	 *
	 */
	
	public CheckSliderText(){
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.insets = new Insets(0,0,0,0);
		super.getJPanel().add(getJCheckBox());
		super.getJPanel().add(getLName(), gridBagConstraints1);
		this.getJCheckBox().addActionListener(this);
		if(cSliderText.isSelected() == false){
			super.setControlEnabled(false);
		}
	}
	/**
	 * Inicializa cSliderText
	 * @return
	 */
	public JCheckBox getJCheckBox(){
		if(cSliderText == null){
			cSliderText = new JCheckBox();
		}
		return cSliderText;
	}
	
	public JLabel getLName(){
		if(lName == null){
			lName = new JLabel();
			lName.setText("Nombre");
			lName.setPreferredSize(new java.awt.Dimension(150,15));
			lName.setSize(150, 15);
		}
		return lName;
	}
	
	/**
	 * Pone nombre al panel en la etiqueta que est encima del slider
	 */
	public void setName(String name){
		lName.setText(name);
	}
	
	/**
	 * Activa o desactiva el slider y el campo de texto 
	 */
	public void setControlEnabled(boolean active){
		this.cSliderText.setEnabled(active);
		this.lName.setEnabled(active);
		this.getJTextField().setEnabled(active);
		super.setControlEnabled(active);
		if(cSliderText.isSelected() == false){
			super.setControlEnabled(false);
		}
		
	}
	
	
	public void actionPerformed(ActionEvent e) {
		super.actionPerformed(e);
		if (e.getSource() == getJCheckBox()){
			super.setControlEnabled(getJCheckBox().isSelected());
		}
	}

	public void setSelected(boolean value){
		this.getJCheckBox().setSelected(value);
	}
	
}
