package org.cresques.ui.raster;

import javax.swing.JCheckBox;

/**
 * Clase que representa a un checkbox obtenido a partir del XML
 * que manda un driver de escritura.
 *
 * @author Nacho Brodin <brodin_ign@gva.es>
 *
 */
public class XMLCheck extends JCheckBox {
    final private static long serialVersionUID = -3370601314380922368L;
    public int numPanel = -1;
    public int posIntoPanel = -1;
    public String position = null;
    public String selected = null;
    public int sizex = 0;
    public int sizey = 0;
    public String text = null;
    public String id = null;

    /**
     * Contructor
     * @param text        texto del checkbox
     * @param select        true si esta seleccionado y false si no lo est.
     */
    public XMLCheck(String text, boolean select) {
        super(text, select);
        this.text = text;

        if (select) {
            selected = new String("yes");
        } else {
            selected = new String("no");
        }
    }

    /**
     * Inicializacin del XMLCheck
     */
    public void init() {
        if ((sizex != 0) && (sizey != 0)) {
            this.setPreferredSize(new java.awt.Dimension(sizex, sizey));
        }
    }
}


