/*
 * Created on 09-ene-2007
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.jdwglib.dwg.readers;

import java.util.HashMap;
import java.util.Map;
import com.iver.cit.jdwglib.dwg.DwgObject;
import com.iver.cit.jdwglib.dwg.objects.DwgArc;
import com.iver.cit.jdwglib.dwg.objects.DwgAttdef;
import com.iver.cit.jdwglib.dwg.objects.DwgAttrib;
import com.iver.cit.jdwglib.dwg.objects.DwgBlock;
import com.iver.cit.jdwglib.dwg.objects.DwgBlockControl;
import com.iver.cit.jdwglib.dwg.objects.DwgBlockHeader;
import com.iver.cit.jdwglib.dwg.objects.DwgCircle;
import com.iver.cit.jdwglib.dwg.objects.DwgDictionary;
import com.iver.cit.jdwglib.dwg.objects.DwgDictionaryVar;
import com.iver.cit.jdwglib.dwg.objects.DwgDimOrd;
import com.iver.cit.jdwglib.dwg.objects.DwgEllipse;
import com.iver.cit.jdwglib.dwg.objects.DwgEndblk;
import com.iver.cit.jdwglib.dwg.objects.DwgFace3D;
import com.iver.cit.jdwglib.dwg.objects.DwgHatch;
import com.iver.cit.jdwglib.dwg.objects.DwgIdBuffer;
import com.iver.cit.jdwglib.dwg.objects.DwgImage;
import com.iver.cit.jdwglib.dwg.objects.DwgImageDef;
import com.iver.cit.jdwglib.dwg.objects.DwgImageDefReactor;
import com.iver.cit.jdwglib.dwg.objects.DwgInsert;
import com.iver.cit.jdwglib.dwg.objects.DwgLayer;
import com.iver.cit.jdwglib.dwg.objects.DwgLayerControl;
import com.iver.cit.jdwglib.dwg.objects.DwgLayerIndex;
import com.iver.cit.jdwglib.dwg.objects.DwgLine;
import com.iver.cit.jdwglib.dwg.objects.DwgLinearDimension;
import com.iver.cit.jdwglib.dwg.objects.DwgLwPolyline;
import com.iver.cit.jdwglib.dwg.objects.DwgMText;
import com.iver.cit.jdwglib.dwg.objects.DwgMeshPolyline;
import com.iver.cit.jdwglib.dwg.objects.DwgMinsert;
import com.iver.cit.jdwglib.dwg.objects.DwgOle2Frame;
import com.iver.cit.jdwglib.dwg.objects.DwgPFacePolyline;
import com.iver.cit.jdwglib.dwg.objects.DwgPoint;
import com.iver.cit.jdwglib.dwg.objects.DwgPolyline2D;
import com.iver.cit.jdwglib.dwg.objects.DwgPolyline3D;
import com.iver.cit.jdwglib.dwg.objects.DwgRasterVariables;
import com.iver.cit.jdwglib.dwg.objects.DwgSeqend;
import com.iver.cit.jdwglib.dwg.objects.DwgSolid;
import com.iver.cit.jdwglib.dwg.objects.DwgSortEntStable;
import com.iver.cit.jdwglib.dwg.objects.DwgSpline;
import com.iver.cit.jdwglib.dwg.objects.DwgText;
import com.iver.cit.jdwglib.dwg.objects.DwgVertex2D;
import com.iver.cit.jdwglib.dwg.objects.DwgVertex3D;
import com.iver.cit.jdwglib.dwg.objects.DwgVertexMesh;
import com.iver.cit.jdwglib.dwg.objects.DwgVertexPFace;
import com.iver.cit.jdwglib.dwg.objects.DwgVertexPFaceFace;
import com.iver.cit.jdwglib.dwg.objects.DwgXRecord;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgArcReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgAttdefReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgAttribReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgBlockControlReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgBlockHeaderReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgBlockReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgCircleReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgDictionaryReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgDictionaryVarReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgDimOrdReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgEllipseReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgEndBlkReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgFace3DReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgHatchReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgIdBufferReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgImageDefReactor1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgImageDefReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgImageReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgInsertReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgLayerControlReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgLayerIndexReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgLayerReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgLineReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgLinearDimensionReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgLwPolylineReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgMTextReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgMeshReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgMinsertReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgOle2FrameReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgPFaceReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgPointReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgPolyline2DReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgPolyline3DReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgRasterVariablesReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgSeqEndReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgSolidReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgSortEntsTableReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgSplineReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgTextReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgVertex2DReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgVertex3DReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgVertexMeshReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgVertexPFaceFaceReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgVertexPFaceReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v1314.DwgXrecordReader1314;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgArcReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgAttdefReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgAttribReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgBlockControlReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgBlockHeaderReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgBlockReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgCircleReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgDictionaryReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgEllipseReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgEndBlkReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgInsertReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgLayerControlReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgLayerReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgLineReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgLinearDimensionReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgLwPolylineReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgMTextReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgMeshReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgPFaceReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgPointReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgPolyline2DReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgPolyline3DReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgSeqEndReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgSolidReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgSplineReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgTextReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgVertex2DReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgVertex3DReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgVertexMeshReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgVertexPFaceFaceReader15;
import com.iver.cit.jdwglib.dwg.readers.objreaders.v15.DwgVertexPFaceReader15;

/**
 * @author azabala
 */
public class DwgObjectReaderPool {
	
	private static final DwgObjectReaderPool _instance = 
		new DwgObjectReaderPool();
	
	private Map obj_readers;
	
	static{
		//READERS FOR DWG V15
		_instance.put(DwgArc.class, "15", new DwgArcReader15());
		_instance.put(DwgAttdef.class, "15", new DwgAttdefReader15());
		_instance.put(DwgAttrib.class, "15", new DwgAttribReader15());
		_instance.put(DwgBlock.class, "15", new DwgBlockReader15());
		_instance.put(DwgBlockControl.class, "15", new DwgBlockControlReader15());
		_instance.put(DwgBlockHeader.class, "15", new DwgBlockHeaderReader15());
		_instance.put(DwgCircle.class, "15", new DwgCircleReader15());
		_instance.put(DwgEllipse.class, "15", new DwgEllipseReader15());
		_instance.put(DwgEndblk.class, "15", new DwgEndBlkReader15());
		_instance.put(DwgInsert.class, "15", new DwgInsertReader15());
		_instance.put(DwgLayer.class, "15", new DwgLayerReader15());
		_instance.put(DwgLayerControl.class, "15", new DwgLayerControlReader15());
		_instance.put(DwgLine.class, "15", new DwgLineReader15());
		_instance.put(DwgLinearDimension.class, "15", new DwgLinearDimensionReader15());
		_instance.put(DwgLwPolyline.class, "15", new DwgLwPolylineReader15());
		_instance.put(DwgMText.class, "15", new DwgMTextReader15());
		_instance.put(DwgPoint.class, "15", new DwgPointReader15());
		_instance.put(DwgPolyline2D.class, "15", new DwgPolyline2DReader15());
		_instance.put(DwgPolyline3D.class, "15", new DwgPolyline3DReader15());
		_instance.put(DwgSeqend.class, "15", new DwgSeqEndReader15());
//		_instance.put(DwgSolid.class, "15", new DwgSolidReader15());
		_instance.put(DwgSpline.class, "15", new DwgSplineReader15());
		_instance.put(DwgText.class, "15", new DwgTextReader15());
		_instance.put(DwgVertex2D.class, "15", new DwgVertex2DReader15());
		_instance.put(DwgVertex3D.class, "15", new DwgVertex3DReader15());
		_instance.put(DwgDictionary.class, "15", new DwgDictionaryReader15());
		_instance.put(DwgVertexPFace.class, "15", new DwgVertexPFaceReader15());
		_instance.put(DwgVertexPFaceFace.class, "15", new DwgVertexPFaceFaceReader15());
		_instance.put(DwgPFacePolyline.class, "15", new DwgPFaceReader15());
		_instance.put(DwgMeshPolyline.class, "15", new DwgMeshReader15());
		_instance.put(DwgVertexMesh.class, "15", new DwgVertexMeshReader15());
		
		
		
		
		//READERS FOR DWG V13 AND V14
		_instance.put(DwgArc.class, "1314", new DwgArcReader1314());
		_instance.put(DwgAttdef.class, "1314", new DwgAttdefReader1314());
		_instance.put(DwgAttrib.class, "1314", new DwgAttribReader1314());
		_instance.put(DwgBlock.class, "1314", new DwgBlockReader1314());
		_instance.put(DwgBlockControl.class, "1314", new DwgBlockControlReader1314());
		_instance.put(DwgBlockHeader.class, "1314", new DwgBlockHeaderReader1314());
		_instance.put(DwgCircle.class, "1314", new DwgCircleReader1314());
		_instance.put(DwgDictionary.class, "1314", new DwgDictionaryReader1314());
		_instance.put(DwgDictionaryVar.class, "1314", new DwgDictionaryVarReader1314());
		_instance.put(DwgDimOrd.class, "1314", new DwgDimOrdReader1314());
		_instance.put(DwgEllipse.class, "1314", new DwgEllipseReader1314());
		_instance.put(DwgEndblk.class, "1314", new DwgEndBlkReader1314());
		_instance.put(DwgFace3D.class, "1314", new DwgFace3DReader1314());
		_instance.put(DwgHatch.class, "1314", new DwgHatchReader1314());
		_instance.put(DwgIdBuffer.class, "1314", new DwgIdBufferReader1314());
		_instance.put(DwgImageDefReactor.class, "1314", new DwgImageDefReactor1314());
		_instance.put(DwgImageDef.class, "1314", new DwgImageDefReader1314());
		_instance.put(DwgImage.class, "1314", new DwgImageReader1314());
		_instance.put(DwgInsert.class, "1314", new DwgInsertReader1314());
		_instance.put(DwgLayer.class, "1314", new DwgLayerReader1314());
		_instance.put(DwgLayerControl.class, "1314", new DwgLayerControlReader1314());
		_instance.put(DwgLayerIndex.class, "1314", new DwgLayerIndexReader1314());
		_instance.put(DwgLine.class, "1314", new DwgLineReader1314());
		_instance.put(DwgLinearDimension.class, "1314", new DwgLinearDimensionReader1314());
		_instance.put(DwgLwPolyline.class, "1314", new DwgLwPolylineReader1314());
		_instance.put(DwgMeshPolyline.class, "1314", new DwgMeshReader1314());
		_instance.put(DwgMinsert.class, "1314", new DwgMinsertReader1314());
		_instance.put(DwgMText.class, "1314", new DwgMTextReader1314());
		_instance.put(DwgOle2Frame.class, "1314", new DwgOle2FrameReader1314());
		_instance.put(DwgPFacePolyline.class, "1314", new DwgPFaceReader1314());
		_instance.put(DwgPoint.class, "1314", new DwgPointReader1314());
		_instance.put(DwgPolyline2D.class, "1314", new DwgPolyline2DReader1314());
		_instance.put(DwgPolyline3D.class, "1314", new DwgPolyline3DReader1314());
		_instance.put(DwgRasterVariables.class, "1314", new DwgRasterVariablesReader1314());
		_instance.put(DwgSeqend.class, "1314", new DwgSeqEndReader1314());
		_instance.put(DwgSortEntStable.class, "1314", new DwgSortEntsTableReader1314());
//		_instance.put(DwgSolid.class, "1314", new DwgSolidReader1314());
		_instance.put(DwgSpline.class, "1314", new DwgSplineReader1314());
		_instance.put(DwgText.class, "1314", new DwgTextReader1314());
		_instance.put(DwgVertex2D.class, "1314", new DwgVertex2DReader1314());
		_instance.put(DwgVertex3D.class, "1314", new DwgVertex3DReader1314());
		_instance.put(DwgXRecord.class, "1314", new DwgXrecordReader1314());
		_instance.put(DwgDictionary.class, "1314", new DwgDictionaryReader1314());
		_instance.put(DwgVertexPFace.class, "1314", new DwgVertexPFaceReader1314());
		_instance.put(DwgVertexPFaceFace.class, "1314", new DwgVertexPFaceFaceReader1314());
		_instance.put(DwgVertexMesh.class, "1314", new DwgVertexMeshReader1314());
	
	}
	
	
	
	public final static DwgObjectReaderPool getInstance(){
		return _instance;
	}
	private DwgObjectReaderPool(){
		obj_readers = new HashMap();
	}
	
	public IDwgObjectReader get(DwgObject obj, String dwgVersion){
		IDwgObjectReader reader = (IDwgObjectReader) obj_readers.
				get(obj.getClass().getName() + dwgVersion);
//		if(reader == null)
//			throw new RuntimeException("No se encuentra la clase para leer "+obj.getClass().getName());
		return reader;
		
	}
	
	public void put(Class dwgObjClass, String dwgVersion, IDwgObjectReader reader){
		if(DwgObject.class.isAssignableFrom(dwgObjClass))
			obj_readers.put(dwgObjClass.getName()+ dwgVersion, reader);
		else
			throw new RuntimeException("Este pool solo admite como entrada clases de entidad de dibujo grfica");
	}
	
}
