package com.iver.cit.gvsig.fmap.rendering.styling.sld;

import java.awt.Color;

import javax.xml.transform.TransformerException;

import org.geotools.filter.ExpressionBuilder;
import org.geotools.filter.Filter;
import org.geotools.filter.parser.ParseException;
import org.geotools.styling.FeatureTypeStyle;
import org.geotools.styling.Fill;
import org.geotools.styling.PolygonSymbolizer;
import org.geotools.styling.Rule;
import org.geotools.styling.SLDTransformer;
import org.geotools.styling.Style;
import org.geotools.styling.StyleBuilder;
import org.geotools.styling.StyleFactory;
import org.geotools.styling.Symbolizer;

public class testSLD {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		StyleFactory styleFactory = StyleFactory.createStyleFactory();
		Style style = styleFactory.createStyle();
		style.setTitle("Titulo");
		style.setAbstract("Abstract");
		style.setName("Nombre");
		
		
	    try{
	        Filter filter = (Filter)ExpressionBuilder.parse("5 < 10");
			Rule myFirstRule = styleFactory.createRule();
			myFirstRule.setFilter(filter);
			
			FeatureTypeStyle featStyle = styleFactory.createFeatureTypeStyle();
			featStyle.setTitle("Titulo FeatureTypeStyle");
			featStyle.setName("Name FeatureTypeStyle");
			featStyle.setFeatureTypeName("Provin");
			featStyle.addRule(myFirstRule);
			
			myFirstRule.setMinScaleDenominator(1000.0);
			myFirstRule.setMaxScaleDenominator(50000.0);
			
			Symbolizer[] theSymbolizers = new Symbolizer[1];
			PolygonSymbolizer sym = styleFactory.createPolygonSymbolizer();
			
			StyleBuilder styleBuilder = new StyleBuilder();			
			Fill theFill = styleBuilder.createFill(Color.BLUE);
			
			sym.setFill(theFill);
			theSymbolizers[0] = sym;
			
			myFirstRule.setSymbolizers(theSymbolizers);
			
			style.addFeatureTypeStyle(featStyle);
			
			
			SLDTransformer st = new SLDTransformer();
			
			System.out.println(st.transform(style));
	        
	     }
	     catch(ParseException e){
	        //...
	     } catch (TransformerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
