/*
 * Created on 23-oct-2004
 */
package com.hardcode.gdbms.engine.data.indexes;

import java.io.IOException;


/**
 * DOCUMENT ME!
 *
 * @author Fernando Gonzlez Corts
 */
public interface BaseIndexSet {
	/**
	 * Cierra el fichero de ndices
	 *
	 * @throws IOException Si se produce un fallo al cerrar
	 */
	public void close() throws IOException;

	/**
	 * Devuelve el ndice nth-simo si se invoc previamente a indexSetComplete
	 * y lanza una excepcin en caso contrario
	 *
	 * @param nth ndice del ndice que se quiere obtener
	 *
	 * @return indice nth-simo
	 *
	 * @throws IOException Si se produce un fallo al recuperar el ndice
	 */
	public long getIndex(long nth) throws IOException;

	/**
	 * Devuelve el nmero de ndices si se invoc previamente a
	 * indexSetComplete y lanza una excepcin en caso contrario
	 *
	 * @return Si se produce un fallo al obtener el nmero de ndices
	 */
	public long getIndexCount();
}
