/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Instituto de Desarrollo Regional and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   Instituto de Desarrollo Regional (Universidad de Castilla La-Mancha)
 *   Campus Universitario s/n
 *   02071 Alabacete
 *   Spain
 *
 *   +34 967 599 200
 */

package org.gvsig.crs.ogr;

/**
 *
 * @author Miguel Garca Jimnez (garciajimenez.miguel@gmail.com)
 *
 */
public class JNIBase {


	protected long cPtr;

	protected native long OGRSpatialReferenceNat() throws crsgdalException;
	protected native void OGRDestroySpatialReferenceNat(long crs);

	protected long createOGRSpatialReference() throws crsgdalException
	{
		cPtr = OGRSpatialReferenceNat();
		//if(cPtr<=0) throw new crsgdalException();
		return cPtr;
	}

	protected void deleteOGRSpatialReference() throws crsgdalException
	{
		if(cPtr>0) OGRDestroySpatialReferenceNat(cPtr);
	}

	protected long getPtr() throws crsgdalException {
		//if (cPtr>0)
			return cPtr;
		//else throw new crsgdalException();
	}

	static {
		String os = System.getProperty("os.name");
		if(os.toLowerCase().startsWith("windows"))
			System.loadLibrary("jgdal060");
		else
			System.loadLibrary("jgdal");
	}
}
