/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Instituto de Desarrollo Regional and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   Instituto de Desarrollo Regional (Universidad de Castilla La-Mancha)
 *   Campus Universitario s/n
 *   02071 Alabacete
 *   Spain
 *
 *   +34 967 599 200
 */

package org.gvsig.crs.ogr;

/**
 * Clase que gestionan las excepciones de gdal
 * 
 * @author Diego Guerrero Sevilla (diego.guerrero@uclm.es)
 *
 */

public class OGRException extends Exception {

	OGRException(String msg){
		super(msg);
	}
	
	public OGRException(int n, String msg, OGRSpatialReference ORGSpace) throws CrsOgrException, crsgdalException
	{
		if(n == 1)
			System.out.println(msg+"Insuficientes parametros para construir el dato");
		else if(n == 2)
			System.out.println(msg+"Insuficiente memoria para construir el dato");
		else if(n == 3)
			System.out.println(msg+"Geometria no soportada");
		else if(n == 4)
			System.out.println(msg+"Operacion no soportada");
		else if(n == 5)
			System.out.println(msg+"Algun dato esta corrupto");
		else if(n == 6)
			System.out.println(msg+"Fallo");
		else if(n == 7)
			System.out.println(msg+"CRS no soportado");
		throw new CrsOgrException(ORGSpace);
		
	}
}