package org.gvsig.remoteClient.gml.factories;

import java.awt.geom.Point2D;
import java.util.Map;

import org.gvsig.remoteClient.gml.types.IXMLType;
import org.gvsig.remoteClient.gml.v2.GMLSimpleFeature_v2;


/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: GeometriesFactory.java,v 1.1.2.1 2007/01/25 16:12:59 jorpiell Exp $
 * $Log: GeometriesFactory.java,v $
 * Revision 1.1.2.1  2007/01/25 16:12:59  jorpiell
 * Se han sustituido las clases por las que hay en el nuevo driver de GML.
 *
 * Revision 1.3  2006/12/29 17:15:48  jorpiell
 * Se tienen en cuenta los simpleTypes y los choices, adems de los atributos multiples
 *
 * Revision 1.2  2006/12/22 11:25:44  csanchez
 * Nuevo parser GML 2.x para gml's sin esquema
 *
 * Revision 1.1  2006/08/10 12:00:49  jorpiell
 * Primer commit del driver de Gml
 *
 *
 */
/**
 * Geometries factory for the RemoteClient project.
 * 
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 * @author Carlos Snchez Perin (sanchez_carper@gva.es)
 * 
 */
public class GeometriesFactory implements IGeometriesFactory{
	/*
	 *  (non-Javadoc)
	 * @see org.gvsig.remoteClient.gml.factories.IGeometriesFactory#createPoint2D(double, double)
	 */
	public Object createPoint2D(double x, double y) {
		return new Point2D.Double(x,y);
	}
	
	/*
	 *  (non-Javadoc)
	 * @see org.gvsig.remoteClient.gml.factories.IGeometriesFactory#createPoint2D(java.awt.geom.Point2D)
	 */
	public Object createPoint2D(Point2D point2D) {
		return new Point2D.Double(point2D.getX(),point2D.getY());
	}

	/*
	 *  (non-Javadoc)
	 * @see org.gvsig.remoteClient.gml.factories.IGeometriesFactory#createMultipoint2D(double[], double[])
	 */
	public Object createMultipoint2D(double[] x, double[] y) {
		// TODO Auto-generated method stub
		return null;
	}

	/*
	 *  (non-Javadoc)
	 * @see org.gvsig.remoteClient.gml.factories.IGeometriesFactory#createSimpleFeature(java.lang.String, java.lang.Object, java.util.ArrayList, java.util.ArrayList)
	 */
	public Object createSimpleFeature(String element, IXMLType type, Map values, Object geometry) {
		GMLSimpleFeature_v2 feature = new GMLSimpleFeature_v2(element,type,values,geometry);
		return feature;
	}

	/*
	 *  (non-Javadoc)
	 * @see org.gvsig.remoteClient.gml.factories.IGeometriesFactory#createGeometry(java.lang.String)
	 */
	public Object createGeometry(String gmlString) {
		return gmlString;
	}


}
