/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package org.gvsig.gui.beans.coordDataInput;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.gvsig.gui.beans.dataInput.DataInputContainer;

public class CoordDataInputContainer extends JPanel {
	private static final long serialVersionUID = -1676893081030157641L;
	private String             pathToImages = "images/";


	private JPanel pCoord = null;
	private JLabel lTitulo1 = null;
	private JLabel lTitulo2 = null;
	private DataInputContainer pDataInput11 = null;
	private DataInputContainer pDataInput12 = null;
	private DataInputContainer pDataInput21 = null;
	private DataInputContainer pDataInput22 = null;

	private String				tituloPanel = "Title";

	/**
	 * This is the default constructor
	 */
	public CoordDataInputContainer() {
		initialize();
	}

	/**
	 * This method initializes this
	 *
	 * @return void
	 */
	private void initialize() {
		setLayout(new BorderLayout());
		add(getPCoord(), BorderLayout.CENTER);
	}

	/**
	 * This method initializes jPanel
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getPCoord() {
		if (pCoord == null) {

			GridBagConstraints gridBagConstraints0 = new GridBagConstraints();
			gridBagConstraints0.gridx = 0;
			gridBagConstraints0.gridy = 0;
			gridBagConstraints0.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints0.weightx = 1.0;
			gridBagConstraints0.insets = new java.awt.Insets(5, 5, 2, 2);

			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.insets = new java.awt.Insets(2, 5, 5, 2);

			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 1;
			gridBagConstraints11.gridy = 0;
			gridBagConstraints11.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints11.weightx = 1.0;
			gridBagConstraints11.insets = new java.awt.Insets(5, 2, 2, 2);
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 2;
			gridBagConstraints12.gridy = 0;
			gridBagConstraints12.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints12.weightx = 1.0;
			gridBagConstraints12.insets = new java.awt.Insets(5, 2, 2, 5);
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 1;
			gridBagConstraints21.gridy = 1;
			gridBagConstraints21.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints21.weightx = 1.0;
			gridBagConstraints21.insets = new java.awt.Insets(2, 2, 5, 2);
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.gridx = 2;
			gridBagConstraints22.gridy = 1;
			gridBagConstraints22.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints22.weightx = 1.0;
			gridBagConstraints22.insets = new java.awt.Insets(2, 2, 5, 5);

			pCoord = new JPanel();
			pCoord.setLayout(new GridBagLayout());
			pCoord.setBorder(javax.swing.BorderFactory.createTitledBorder(null, tituloPanel, javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10), null));

			pCoord.add(getLTitulo1(), gridBagConstraints0);
			pCoord.add(getLTitulo2(), gridBagConstraints1);
			pCoord.add(getPDataInput11(), gridBagConstraints11);
			pCoord.add(getPDataInput12(), gridBagConstraints12);
			pCoord.add(getPDataInput21(), gridBagConstraints21);
			pCoord.add(getPDataInput22(), gridBagConstraints22);
		}
		return pCoord;
	}

	private JLabel getLTitulo1(){
		if (lTitulo1 == null){
			lTitulo1 = new JLabel(new ImageIcon(getClass().getResource(pathToImages + "upleft.png")));
		}
		return lTitulo1;
	}

	private JLabel getLTitulo2(){
		if (lTitulo2 == null){
			lTitulo2 = new JLabel(new ImageIcon(getClass().getResource(pathToImages + "downright.png")));
		}
		return lTitulo2;
	}

	/**
	 * This method initializes jPanel
	 *
	 * @return javax.swing.JPanel
	 */
	public DataInputContainer getPDataInput11() {
		if (pDataInput11 == null) {
			pDataInput11 = new DataInputContainer();
			pDataInput11.setLabelText("Xx:");
		}
		return pDataInput11;
	}

	/**
	 * This method initializes jPanel1
	 *
	 * @return javax.swing.JPanel
	 */
	public DataInputContainer getPDataInput12() {
		if (pDataInput12 == null) {
			pDataInput12 = new DataInputContainer();
			pDataInput12.setLabelText("Yy:");
		}
		return pDataInput12;
	}

	/**
	 * This method initializes jPanel2
	 *
	 * @return javax.swing.JPanel
	 */
	public DataInputContainer getPDataInput21() {
		if (pDataInput21 == null) {
			pDataInput21 = new DataInputContainer();
			pDataInput21.setLabelText("X:");
		}
		return pDataInput21;
	}

	/**
	 * This method initializes jPanel3
	 *
	 * @return javax.swing.JPanel
	 */
	public DataInputContainer getPDataInput22() {
		if (pDataInput22 == null) {
			pDataInput22 = new DataInputContainer();
			pDataInput22.setLabelText("Y:");
		}
		return pDataInput22;
	}

	/**
	 * Mtodo para introducir los campos del componente. Por orden de
	 * arriba a abajo se introducen las cadenas que tienen que ir en el panel.
	 * @param tPanel
	 * @param titulo1
	 * @param celda11
	 * @param celda12
	 * @param titulo2
	 * @param celda21
	 * @param celda22
	 */
	public void setParameters(String tPanel, String titulo1, String celda11, String celda12, String titulo2, String celda21, String celda22){
		this.tituloPanel = tPanel;
		this.pDataInput11.setLabelText(celda11);
		this.pDataInput12.setLabelText(celda12);
		this.pDataInput21.setLabelText(celda21);
		this.pDataInput22.setLabelText(celda22);
		pCoord.setBorder(javax.swing.BorderFactory.createTitledBorder(null, tituloPanel, javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10), null));

	}

	/**
	 * Indica si los campos de texto admiten valores
	 * decimales o no.
	 * @param dec
	 */
	public void setDecimalValues(boolean dec){
		this.pDataInput11.setDecimal(dec);
		this.pDataInput12.setDecimal(dec);
		this.pDataInput21.setDecimal(dec);
		this.pDataInput22.setDecimal(dec);
	}


	/**
	 * Indica si los campos de texto admiten cadenas de
	 * de caracteres.
	 * @param car
	 */
	public void setCaracterValues(boolean car){
		this.pDataInput11.setCaracter(car);
		this.pDataInput12.setCaracter(car);
		this.pDataInput21.setCaracter(car);
		this.pDataInput22.setCaracter(car);
	}


	/**
	 * Devuelve los valores del panel por orden de izquierda a derecha
	 * y de arriba a bajo.
	 * @return
	 */
	public String[] getValues(){
		String[] values = {this.pDataInput11.getValue(),
					this.pDataInput12.getValue(),
					this.pDataInput21.getValue(),
					this.pDataInput22.getValue()
		};
		return values;
	}

	/**
	 * Asigna los valores del panel por orden de izquierda a derecha
	 * y de arriba a bajo.
	 * @return
	 */
	public void setValues(String[] values){
		this.pDataInput11.setValue(values[0]);
		this.pDataInput12.setValue(values[1]);
		this.pDataInput21.setValue(values[2]);
		this.pDataInput22.setValue(values[3]);
	}
}
