/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*/
package org.gvsig.gui.beans.graphic.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JLabel;
import javax.swing.event.TableModelEvent;

import org.gvsig.gui.beans.graphic.GraphicContainer;
import org.jfree.chart.ChartPanel;

/**
 * 
 * @author Nacho Brodin <brodin_ign@gva.es>
 *
 */
public class GraphicListener implements MouseListener, ActionListener, MouseMotionListener{

	private GraphicContainer		graphicContainer = null;
	private boolean					move = false;
	private JLabel					left = null;
	private JLabel					right = null;
	
	public GraphicListener(GraphicContainer graphicContainer){
		this.graphicContainer = graphicContainer;
	}
	
	public void mouseDragged(MouseEvent e) {
		if(move){
			if(e.getSource() == left)	
				left.setLocation(left.getLocation().x + e.getX(), left.getLocation().y);
			
			if(e.getSource() == right)
				right.setLocation(right.getLocation().x + e.getX(), right.getLocation().y);
		}	
		ChartPanel cp = graphicContainer.getPGraphic().getChart();

		//System.out.println(cp.getScaleX());
		
	}

	public void mousePressed(MouseEvent e) {
		move = true;
	}

	public void mouseReleased(MouseEvent e) {
		move = false;		
	}
	
	public void setLabels(JLabel left, JLabel right){
		this.left = left;
		this.right = right;        
	}
	
	public void mouseMoved(MouseEvent e) {
			
	}

	private void initialize(){

	}
	
	public void actionPerformed(ActionEvent e) {
		
	}

	public void tableChanged(TableModelEvent e) {
				
	}

	public void mouseClicked(MouseEvent e) {
		
	}

	public void mouseEntered(MouseEvent e) {
				
	}

	public void mouseExited(MouseEvent e) {
				
	}



}
