/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2005 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*/
package org.gvsig.gui.beans.slidertext.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.gvsig.gui.beans.slidertext.SliderTextContainer;

/**
 * 
 * @author Nacho Brodin <brodin_ign@gva.es>
 *
 */
public class SliderTextListener implements ChangeListener, ActionListener, KeyListener, FocusListener{

	private SliderTextContainer		sliderTextContainer = null;
	private String 					lastText = "";
		
	public SliderTextListener(SliderTextContainer panel){
		this.sliderTextContainer = panel;
	}
	
	private void initialize(){
		
	}
	
	public void actionPerformed(ActionEvent e) {
		
	}

	public void stateChanged(ChangeEvent e) {
		//Modificamos la caja de texto con el valor de la posicin del slider
		sliderTextContainer.getText().setText(sliderTextContainer.getSlider().getValue()+"");
	}

	public void keyPressed(KeyEvent e) {
		lastText = sliderTextContainer.getText().getText();
	}

	public void keyReleased(KeyEvent e) {
		validateTextField();
		
		//Asignamos la nueva posicin de la barra cuando se modifica el texto
		if(e.getKeyCode() == 10){
			sliderTextContainer.getSlider().setValue(Double.valueOf(sliderTextContainer.getText().getText()).intValue());
		}
	}

	public void keyTyped(KeyEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void focusGained(FocusEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void focusLost(FocusEvent e) {
		validateTextField();
	}

	/**
	 * Comprobamos que los datos introducidos por el texto sean correctos sino 
	 * borramos el ltimo caracter
	 */
	private void validateTextField(){
		try{
			Double.valueOf(sliderTextContainer.getText().getText());
		}catch(NumberFormatException exc){
			if(!sliderTextContainer.getText().getText().equals(""))
				sliderTextContainer.getText().setText(lastText);
			else
				sliderTextContainer.getText().setText("0");
		}
	}
}
