/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package org.gvsig.gui.beans.table.models;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

/**
 * Cargador de Modelos
 * 
 * @author Nacho Brodin (brodin_ign@gva.es)
 *
 */
public class ModelLoader{
	
	private static DefaultTableModel tableModel = null;
	
	public JTable load(String model, String[] columnNames){
		if(model == null || model.equals(""))
			return null;
		
		JTable table = null;
		
		if(model.equals("ListModel")){
			tableModel = new ListModel(columnNames);
			table = new JTable(tableModel);
		}
		
		if(model.equals("TreeRadioButtonModel")){
			tableModel = new TreeRadioButtonModel(columnNames);
			table = new JTable(tableModel);
			TableColumn column = null;

	        for (int i = 0; i < columnNames.length - 1; i++) {
	        	column = table.getColumnModel().getColumn(i);
	            column.setCellRenderer(new TreeRadioButtonColumnRenderer());
	            column.setCellEditor(new TreeRadioButtonColumnEditor());
	        }
		}
		
		if(model.equals("RadioButtonModel")){
			tableModel = new RadioButtonModel(columnNames);
			table = new JTable(tableModel);
			TableColumn column = null;
			
			for (int i = 0; i < columnNames.length - 1; i++){
				column = table.getColumnModel().getColumn(i);
				column.setCellRenderer(new TreeRadioButtonColumnRenderer());
	            column.setCellEditor(new TreeRadioButtonColumnEditor());
			}
		}
		
		if(model.equals("CheckBoxModel")){
			tableModel = new CheckBoxModel(columnNames);
			table = new JTable(tableModel);
			TableColumn column = null;
			
			for (int i = 0; i < columnNames.length - 1; i++){
				column = table.getColumnModel().getColumn(i);
				column.setCellRenderer(new CheckBoxColumnRenderer());
	            column.setCellEditor(new CheckBoxColumnEditor());
			}
		}
		
		
		if(model.equals("TableButtonModel")){
			tableModel = new TableButtonModel(columnNames);
			table = new JTable(tableModel);
			TableColumn column = null;
	        
	        column = table.getColumnModel().getColumn(0);
	        column.setCellRenderer(new TableColorButtonColumnRenderer(true));
            column.setCellEditor(new TableColorButtonColumnEditor((TableButtonModel)tableModel, table));
            
            column = table.getColumnModel().getColumn(4);
            column.setCellRenderer(new TableSelectorButtonColumnRenderer());
            column.setCellEditor(new TableSelectorButtonColumnEditor());
		}
		return table;
	}
	
	/**
	 * Obtiene el modelo de la tabla
	 * @return DefaultTableModel
	 */
	public DefaultTableModel getTableModel(){
		return tableModel;
	}
}
